"use strict";

var _babelTemplate = require("babel-template");

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function (_ref) {
  var t = _ref.types;

  var tmpl = (0, _babelTemplate2.default)("\n    (function(){\n      var CHILD = CLASS_EXPRESSION\n      Object.defineProperty(CHILD, \"name\", { value: CHILD_NAME, configurable: true });\n\n      if (\"onInherited\" in PARENT) {\n        if (typeof PARENT.onInherited == 'function') {\n          var RETURNED_NEW_CHILD = PARENT.onInherited(CHILD);\n          if (RETURNED_NEW_CHILD !== void 0) {\n            if (typeof RETURNED_NEW_CHILD == 'function' && RETURNED_NEW_CHILD.name !== CHILD_NAME) {\n              Object.defineProperty(RETURNED_NEW_CHILD, \"name\", { value: CHILD_NAME, configurable: true });\n            }\n            CHILD = RETURNED_NEW_CHILD;\n          }\n        } else {\n          throw new TypeError(\"Attempted to call onInherited, but it was not a function\");\n        }\n      }\n\n      return CHILD;\n    })();\n  ");

  function transform(childClassName, path) {
    var PARENT = path.node.superClass;
    var CHILD = path.scope.generateUidIdentifier(childClassName);
    var CLASS_EXPRESSION = t.classExpression(null, PARENT, path.node.body, []);
    // Don't transform *this* class expression, or we'll loop forever
    CLASS_EXPRESSION.__babelPluginTransformClassInheritedHook_skip = true;
    var RETURNED_NEW_CHILD = path.scope.generateUidIdentifier(childClassName);
    var CHILD_NAME = t.stringLiteral(childClassName || "class");

    return tmpl({
      CHILD_NAME: CHILD_NAME,
      CHILD: CHILD,
      CLASS_EXPRESSION: CLASS_EXPRESSION,
      RETURNED_NEW_CHILD: RETURNED_NEW_CHILD,
      PARENT: PARENT
    });
  }

  return {
    visitor: {
      "ClassDeclaration|ClassExpression": function ClassDeclarationClassExpression(path) {
        if (!path.node.superClass) return;
        if (path.node.__babelPluginTransformClassInheritedHook_skip) return;

        var childClassName;

        if (t.isIdentifier(path.node.id)) {
          childClassName = path.node.id.name;
        } else if (path.node.id == null && t.isVariableDeclarator(path.parentPath.node)) {
          childClassName = path.parentPath.node.id.name;
        }

        var expressionStatement = transform(childClassName, path);

        if (t.isClassDeclaration(path.node)) {
          path.replaceWith(t.variableDeclaration("var", [t.variableDeclarator(t.identifier(childClassName), expressionStatement.expression)]));
        } else if (t.isClassExpression(path.node)) {
          path.replaceWith(expressionStatement.expression);
        }
      }
    }
  };
};