'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _chai = require('chai');

var _chai2 = _interopRequireDefault(_chai);

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _sinonChai = require('sinon-chai');

var _sinonChai2 = _interopRequireDefault(_sinonChai);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_chai2.default.use(_sinonChai2.default);

describe("Class.onInherited", function () {
  describe("is called when a class is inherited from", function () {
    it("using named class declarations", function () {
      var callback = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child = function (_Parent) {
          (0, _inherits3.default)(_Child, _Parent);

          function _Child() {
            (0, _classCallCheck3.default)(this, _Child);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child).apply(this, arguments));
          }

          return _Child;
        }(Parent);

        Object.defineProperty(_Child, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child2 = Parent.onInherited(_Child);

            if (_Child2 !== void 0) {
              if (typeof _Child2 == 'function' && _Child2.name !== 'Child') {
                Object.defineProperty(_Child2, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child = _Child2;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("using anonymous class expressions with variable declaration", function () {
      var callback = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child3 = function (_Parent2) {
          (0, _inherits3.default)(_Child3, _Parent2);

          function _Child3() {
            (0, _classCallCheck3.default)(this, _Child3);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child3).apply(this, arguments));
          }

          return _Child3;
        }(Parent);

        Object.defineProperty(_Child3, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child4 = Parent.onInherited(_Child3);

            if (_Child4 !== void 0) {
              if (typeof _Child4 == 'function' && _Child4.name !== 'Child') {
                Object.defineProperty(_Child4, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child3 = _Child4;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child3;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("using named class expressions saved as variables", function () {
      var callback = _sinon2.default.spy();

      var Parent = function () {
        function NamedParent() {
          (0, _classCallCheck3.default)(this, NamedParent);
        }

        (0, _createClass3.default)(NamedParent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return NamedParent;
      }();

      var Child = function () {
        var _NamedChild = function (_Parent3) {
          (0, _inherits3.default)(_NamedChild, _Parent3);

          function _NamedChild() {
            (0, _classCallCheck3.default)(this, _NamedChild);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild).apply(this, arguments));
          }

          return _NamedChild;
        }(Parent);

        Object.defineProperty(_NamedChild, "name", {
          value: 'NamedChild',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _NamedChild2 = Parent.onInherited(_NamedChild);

            if (_NamedChild2 !== void 0) {
              if (typeof _NamedChild2 == 'function' && _NamedChild2.name !== 'NamedChild') {
                Object.defineProperty(_NamedChild2, "name", {
                  value: 'NamedChild',
                  configurable: true
                });
              }

              _NamedChild = _NamedChild2;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NamedChild;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("using anonymous class expressions on object literal properties", function () {
      var callback = _sinon2.default.spy();

      var Parents = {
        Parent: function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              callback(inheritor);
            }
          }]);
          return Parent;
        }()
      };

      var Children = {
        Child: function () {
          var _temp = function (_Parents$Parent) {
            (0, _inherits3.default)(_temp, _Parents$Parent);

            function _temp() {
              (0, _classCallCheck3.default)(this, _temp);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp).apply(this, arguments));
            }

            return _temp;
          }(Parents.Parent);

          Object.defineProperty(_temp, "name", {
            value: 'class',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _temp2 = Parents.Parent.onInherited(_temp);

              if (_temp2 !== void 0) {
                if (typeof _temp2 == 'function' && _temp2.name !== 'class') {
                  Object.defineProperty(_temp2, "name", {
                    value: 'class',
                    configurable: true
                  });
                }

                _temp = _temp2;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _temp;
        }()
      };

      (0, _chai.expect)(callback).to.have.been.calledWith(Children.Child);
    });

    it("using named class expressions on object literal properties", function () {
      var callback = _sinon2.default.spy();

      var Parents = {
        Parent: function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              callback(inheritor);
            }
          }]);
          return NamedParent;
        }()
      };

      var Children = {
        Child: function () {
          var _NamedChild3 = function (_Parents$Parent2) {
            (0, _inherits3.default)(_NamedChild3, _Parents$Parent2);

            function _NamedChild3() {
              (0, _classCallCheck3.default)(this, _NamedChild3);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild3).apply(this, arguments));
            }

            return _NamedChild3;
          }(Parents.Parent);

          Object.defineProperty(_NamedChild3, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _NamedChild4 = Parents.Parent.onInherited(_NamedChild3);

              if (_NamedChild4 !== void 0) {
                if (typeof _NamedChild4 == 'function' && _NamedChild4.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild4, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild3 = _NamedChild4;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild3;
        }()
      };

      (0, _chai.expect)(callback).to.have.been.calledWith(Children.Child);
    });
  });
  describe("is called when a class is inherited from (down the chain)", function () {
    it("using named class declarations", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function () {
        var _Parent4 = function (_Grandparent) {
          (0, _inherits3.default)(_Parent4, _Grandparent);

          function _Parent4() {
            (0, _classCallCheck3.default)(this, _Parent4);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent4).apply(this, arguments));
          }

          return _Parent4;
        }(Grandparent);

        Object.defineProperty(_Parent4, "name", {
          value: 'Parent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _Parent5 = Grandparent.onInherited(_Parent4);

            if (_Parent5 !== void 0) {
              if (typeof _Parent5 == 'function' && _Parent5.name !== 'Parent') {
                Object.defineProperty(_Parent5, "name", {
                  value: 'Parent',
                  configurable: true
                });
              }

              _Parent4 = _Parent5;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Parent4;
      }();

      var Child = function () {
        var _Child5 = function (_Parent6) {
          (0, _inherits3.default)(_Child5, _Parent6);

          function _Child5() {
            (0, _classCallCheck3.default)(this, _Child5);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child5).apply(this, arguments));
          }

          return _Child5;
        }(Parent);

        Object.defineProperty(_Child5, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child6 = Parent.onInherited(_Child5);

            if (_Child6 !== void 0) {
              if (typeof _Child6 == 'function' && _Child6.name !== 'Child') {
                Object.defineProperty(_Child6, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child5 = _Child6;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child5;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("using anonymous class expressions with variable declaration", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function () {
        var _Parent7 = function (_Grandparent2) {
          (0, _inherits3.default)(_Parent7, _Grandparent2);

          function _Parent7() {
            (0, _classCallCheck3.default)(this, _Parent7);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent7).apply(this, arguments));
          }

          return _Parent7;
        }(Grandparent);

        Object.defineProperty(_Parent7, "name", {
          value: 'Parent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _Parent8 = Grandparent.onInherited(_Parent7);

            if (_Parent8 !== void 0) {
              if (typeof _Parent8 == 'function' && _Parent8.name !== 'Parent') {
                Object.defineProperty(_Parent8, "name", {
                  value: 'Parent',
                  configurable: true
                });
              }

              _Parent7 = _Parent8;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Parent7;
      }();

      var Child = function () {
        var _Child7 = function (_Parent9) {
          (0, _inherits3.default)(_Child7, _Parent9);

          function _Child7() {
            (0, _classCallCheck3.default)(this, _Child7);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child7).apply(this, arguments));
          }

          return _Child7;
        }(Parent);

        Object.defineProperty(_Child7, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child8 = Parent.onInherited(_Child7);

            if (_Child8 !== void 0) {
              if (typeof _Child8 == 'function' && _Child8.name !== 'Child') {
                Object.defineProperty(_Child8, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child7 = _Child8;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child7;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("using named class expressions saved as variables", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function NamedGrandparent() {
          (0, _classCallCheck3.default)(this, NamedGrandparent);
        }

        (0, _createClass3.default)(NamedGrandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return NamedGrandparent;
      }();

      var Parent = function () {
        var _NamedParent = function (_Grandparent3) {
          (0, _inherits3.default)(_NamedParent, _Grandparent3);

          function _NamedParent() {
            (0, _classCallCheck3.default)(this, _NamedParent);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent).apply(this, arguments));
          }

          return _NamedParent;
        }(Grandparent);

        Object.defineProperty(_NamedParent, "name", {
          value: 'NamedParent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _NamedParent2 = Grandparent.onInherited(_NamedParent);

            if (_NamedParent2 !== void 0) {
              if (typeof _NamedParent2 == 'function' && _NamedParent2.name !== 'NamedParent') {
                Object.defineProperty(_NamedParent2, "name", {
                  value: 'NamedParent',
                  configurable: true
                });
              }

              _NamedParent = _NamedParent2;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NamedParent;
      }();

      var Child = function () {
        var _NamedChild5 = function (_Parent10) {
          (0, _inherits3.default)(_NamedChild5, _Parent10);

          function _NamedChild5() {
            (0, _classCallCheck3.default)(this, _NamedChild5);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild5).apply(this, arguments));
          }

          return _NamedChild5;
        }(Parent);

        Object.defineProperty(_NamedChild5, "name", {
          value: 'NamedChild',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _NamedChild6 = Parent.onInherited(_NamedChild5);

            if (_NamedChild6 !== void 0) {
              if (typeof _NamedChild6 == 'function' && _NamedChild6.name !== 'NamedChild') {
                Object.defineProperty(_NamedChild6, "name", {
                  value: 'NamedChild',
                  configurable: true
                });
              }

              _NamedChild5 = _NamedChild6;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NamedChild5;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("using anonymous class expressions on object literal properties", function () {
      var callback = _sinon2.default.spy();

      var Grandparents = {
        Grandparent: function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              callback(inheritor);
            }
          }]);
          return Grandparent;
        }()
      };

      var Parents = {
        Parent: function () {
          var _temp3 = function (_Grandparents$Grandpa) {
            (0, _inherits3.default)(_temp3, _Grandparents$Grandpa);

            function _temp3() {
              (0, _classCallCheck3.default)(this, _temp3);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp3).apply(this, arguments));
            }

            return _temp3;
          }(Grandparents.Grandparent);

          Object.defineProperty(_temp3, "name", {
            value: 'class',
            configurable: true
          });

          if ("onInherited" in Grandparents.Grandparent) {
            if (typeof Grandparents.Grandparent.onInherited == 'function') {
              var _temp4 = Grandparents.Grandparent.onInherited(_temp3);

              if (_temp4 !== void 0) {
                if (typeof _temp4 == 'function' && _temp4.name !== 'class') {
                  Object.defineProperty(_temp4, "name", {
                    value: 'class',
                    configurable: true
                  });
                }

                _temp3 = _temp4;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _temp3;
        }()
      };

      var Children = {
        Child: function () {
          var _temp5 = function (_Parents$Parent3) {
            (0, _inherits3.default)(_temp5, _Parents$Parent3);

            function _temp5() {
              (0, _classCallCheck3.default)(this, _temp5);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp5).apply(this, arguments));
            }

            return _temp5;
          }(Parents.Parent);

          Object.defineProperty(_temp5, "name", {
            value: 'class',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _temp6 = Parents.Parent.onInherited(_temp5);

              if (_temp6 !== void 0) {
                if (typeof _temp6 == 'function' && _temp6.name !== 'class') {
                  Object.defineProperty(_temp6, "name", {
                    value: 'class',
                    configurable: true
                  });
                }

                _temp5 = _temp6;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _temp5;
        }()
      };

      (0, _chai.expect)(callback).to.have.been.calledWith(Children.Child);
    });

    it("using named class expressions on object literal properties", function () {
      var callback = _sinon2.default.spy();

      var Grandparents = {
        Grandparent: function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              callback(inheritor);
            }
          }]);
          return NamedGrandparent;
        }()
      };

      var Parents = {
        Parent: function () {
          var _NamedParent3 = function (_Grandparents$Grandpa2) {
            (0, _inherits3.default)(_NamedParent3, _Grandparents$Grandpa2);

            function _NamedParent3() {
              (0, _classCallCheck3.default)(this, _NamedParent3);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent3).apply(this, arguments));
            }

            return _NamedParent3;
          }(Grandparents.Grandparent);

          Object.defineProperty(_NamedParent3, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparents.Grandparent) {
            if (typeof Grandparents.Grandparent.onInherited == 'function') {
              var _NamedParent4 = Grandparents.Grandparent.onInherited(_NamedParent3);

              if (_NamedParent4 !== void 0) {
                if (typeof _NamedParent4 == 'function' && _NamedParent4.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent4, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent3 = _NamedParent4;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent3;
        }()
      };

      var Children = {
        Child: function () {
          var _NamedChild7 = function (_Parents$Parent4) {
            (0, _inherits3.default)(_NamedChild7, _Parents$Parent4);

            function _NamedChild7() {
              (0, _classCallCheck3.default)(this, _NamedChild7);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild7).apply(this, arguments));
            }

            return _NamedChild7;
          }(Parents.Parent);

          Object.defineProperty(_NamedChild7, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _NamedChild8 = Parents.Parent.onInherited(_NamedChild7);

              if (_NamedChild8 !== void 0) {
                if (typeof _NamedChild8 == 'function' && _NamedChild8.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild8, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild7 = _NamedChild8;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild7;
        }()
      };

      (0, _chai.expect)(callback).to.have.been.calledWith(Children.Child);
    });
  });
  describe("can be overriden by an intermediate class in the prototype chain", function () {
    it("using named class declarations", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function () {
        var _Parent11 = function (_Grandparent4) {
          (0, _inherits3.default)(_Parent11, _Grandparent4);

          function _Parent11() {
            (0, _classCallCheck3.default)(this, _Parent11);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent11).apply(this, arguments));
          }

          (0, _createClass3.default)(_Parent11, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return _Parent11;
        }(Grandparent);

        Object.defineProperty(_Parent11, "name", {
          value: 'Parent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _Parent12 = Grandparent.onInherited(_Parent11);

            if (_Parent12 !== void 0) {
              if (typeof _Parent12 == 'function' && _Parent12.name !== 'Parent') {
                Object.defineProperty(_Parent12, "name", {
                  value: 'Parent',
                  configurable: true
                });
              }

              _Parent11 = _Parent12;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Parent11;
      }();

      var Child = function () {
        var _Child9 = function (_Parent13) {
          (0, _inherits3.default)(_Child9, _Parent13);

          function _Child9() {
            (0, _classCallCheck3.default)(this, _Child9);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child9).apply(this, arguments));
          }

          return _Child9;
        }(Parent);

        Object.defineProperty(_Child9, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child10 = Parent.onInherited(_Child9);

            if (_Child10 !== void 0) {
              if (typeof _Child10 == 'function' && _Child10.name !== 'Child') {
                Object.defineProperty(_Child10, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child9 = _Child10;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child9;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Parent);
      (0, _chai.expect)(callback).not.to.have.been.calledWith(Child);
    });

    it("using anonymous class expressions with variable declaration", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function () {
        var _Parent14 = function (_Grandparent5) {
          (0, _inherits3.default)(_Parent14, _Grandparent5);

          function _Parent14() {
            (0, _classCallCheck3.default)(this, _Parent14);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent14).apply(this, arguments));
          }

          (0, _createClass3.default)(_Parent14, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return _Parent14;
        }(Grandparent);

        Object.defineProperty(_Parent14, "name", {
          value: 'Parent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _Parent15 = Grandparent.onInherited(_Parent14);

            if (_Parent15 !== void 0) {
              if (typeof _Parent15 == 'function' && _Parent15.name !== 'Parent') {
                Object.defineProperty(_Parent15, "name", {
                  value: 'Parent',
                  configurable: true
                });
              }

              _Parent14 = _Parent15;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Parent14;
      }();

      var Child = function () {
        var _Child11 = function (_Parent16) {
          (0, _inherits3.default)(_Child11, _Parent16);

          function _Child11() {
            (0, _classCallCheck3.default)(this, _Child11);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child11).apply(this, arguments));
          }

          return _Child11;
        }(Parent);

        Object.defineProperty(_Child11, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child12 = Parent.onInherited(_Child11);

            if (_Child12 !== void 0) {
              if (typeof _Child12 == 'function' && _Child12.name !== 'Child') {
                Object.defineProperty(_Child12, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child11 = _Child12;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child11;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Parent);
      (0, _chai.expect)(callback).not.to.have.been.calledWith(Child);
    });

    it("using named class expressions saved as variables", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function NamedGrandparent() {
          (0, _classCallCheck3.default)(this, NamedGrandparent);
        }

        (0, _createClass3.default)(NamedGrandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return NamedGrandparent;
      }();

      var Parent = function () {
        var _NamedParent5 = function (_Grandparent6) {
          (0, _inherits3.default)(_NamedParent5, _Grandparent6);

          function _NamedParent5() {
            (0, _classCallCheck3.default)(this, _NamedParent5);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent5).apply(this, arguments));
          }

          (0, _createClass3.default)(_NamedParent5, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return _NamedParent5;
        }(Grandparent);

        Object.defineProperty(_NamedParent5, "name", {
          value: 'NamedParent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _NamedParent6 = Grandparent.onInherited(_NamedParent5);

            if (_NamedParent6 !== void 0) {
              if (typeof _NamedParent6 == 'function' && _NamedParent6.name !== 'NamedParent') {
                Object.defineProperty(_NamedParent6, "name", {
                  value: 'NamedParent',
                  configurable: true
                });
              }

              _NamedParent5 = _NamedParent6;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NamedParent5;
      }();

      var Child = function () {
        var _NamedChild9 = function (_Parent17) {
          (0, _inherits3.default)(_NamedChild9, _Parent17);

          function _NamedChild9() {
            (0, _classCallCheck3.default)(this, _NamedChild9);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild9).apply(this, arguments));
          }

          return _NamedChild9;
        }(Parent);

        Object.defineProperty(_NamedChild9, "name", {
          value: 'NamedChild',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _NamedChild10 = Parent.onInherited(_NamedChild9);

            if (_NamedChild10 !== void 0) {
              if (typeof _NamedChild10 == 'function' && _NamedChild10.name !== 'NamedChild') {
                Object.defineProperty(_NamedChild10, "name", {
                  value: 'NamedChild',
                  configurable: true
                });
              }

              _NamedChild9 = _NamedChild10;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NamedChild9;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Parent);
      (0, _chai.expect)(callback).not.to.have.been.calledWith(Child);
    });

    it("using anonymous class expressions on object literal properties", function () {
      var callback = _sinon2.default.spy();

      var Grandparents = {
        Grandparent: function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              callback(inheritor);
            }
          }]);
          return Grandparent;
        }()
      };

      var Parents = {
        Parent: function () {
          var _temp7 = function (_Grandparents$Grandpa3) {
            (0, _inherits3.default)(_temp7, _Grandparents$Grandpa3);

            function _temp7() {
              (0, _classCallCheck3.default)(this, _temp7);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp7).apply(this, arguments));
            }

            (0, _createClass3.default)(_temp7, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return _temp7;
          }(Grandparents.Grandparent);

          Object.defineProperty(_temp7, "name", {
            value: 'class',
            configurable: true
          });

          if ("onInherited" in Grandparents.Grandparent) {
            if (typeof Grandparents.Grandparent.onInherited == 'function') {
              var _temp8 = Grandparents.Grandparent.onInherited(_temp7);

              if (_temp8 !== void 0) {
                if (typeof _temp8 == 'function' && _temp8.name !== 'class') {
                  Object.defineProperty(_temp8, "name", {
                    value: 'class',
                    configurable: true
                  });
                }

                _temp7 = _temp8;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _temp7;
        }()
      };

      var Children = {
        Child: function () {
          var _temp9 = function (_Parents$Parent5) {
            (0, _inherits3.default)(_temp9, _Parents$Parent5);

            function _temp9() {
              (0, _classCallCheck3.default)(this, _temp9);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp9).apply(this, arguments));
            }

            return _temp9;
          }(Parents.Parent);

          Object.defineProperty(_temp9, "name", {
            value: 'class',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _temp10 = Parents.Parent.onInherited(_temp9);

              if (_temp10 !== void 0) {
                if (typeof _temp10 == 'function' && _temp10.name !== 'class') {
                  Object.defineProperty(_temp10, "name", {
                    value: 'class',
                    configurable: true
                  });
                }

                _temp9 = _temp10;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _temp9;
        }()
      };

      (0, _chai.expect)(callback).to.have.been.calledWith(Parents.Parent);
      (0, _chai.expect)(callback).not.to.have.been.calledWith(Children.Child);
    });

    it("using named class expressions on object literal properties", function () {
      var callback = _sinon2.default.spy();

      var Grandparents = {
        Grandparent: function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              callback(inheritor);
            }
          }]);
          return NamedGrandparent;
        }()
      };

      var Parents = {
        Parent: function () {
          var _NamedParent7 = function (_Grandparents$Grandpa4) {
            (0, _inherits3.default)(_NamedParent7, _Grandparents$Grandpa4);

            function _NamedParent7() {
              (0, _classCallCheck3.default)(this, _NamedParent7);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent7).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedParent7, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return _NamedParent7;
          }(Grandparents.Grandparent);

          Object.defineProperty(_NamedParent7, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparents.Grandparent) {
            if (typeof Grandparents.Grandparent.onInherited == 'function') {
              var _NamedParent8 = Grandparents.Grandparent.onInherited(_NamedParent7);

              if (_NamedParent8 !== void 0) {
                if (typeof _NamedParent8 == 'function' && _NamedParent8.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent8, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent7 = _NamedParent8;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent7;
        }()
      };

      var Children = {
        Child: function () {
          var _NamedChild11 = function (_Parents$Parent6) {
            (0, _inherits3.default)(_NamedChild11, _Parents$Parent6);

            function _NamedChild11() {
              (0, _classCallCheck3.default)(this, _NamedChild11);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild11).apply(this, arguments));
            }

            return _NamedChild11;
          }(Parents.Parent);

          Object.defineProperty(_NamedChild11, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _NamedChild12 = Parents.Parent.onInherited(_NamedChild11);

              if (_NamedChild12 !== void 0) {
                if (typeof _NamedChild12 == 'function' && _NamedChild12.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild12, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild11 = _NamedChild12;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild11;
        }()
      };

      (0, _chai.expect)(callback).to.have.been.calledWith(Parents.Parent);
      (0, _chai.expect)(callback).not.to.have.been.calledWith(Children.Child);
    });
  });
  describe("can redefine the value of the declared class", function () {
    it("using named class declarations", function () {
      var replacement = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            return replacement;
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child13 = function (_Parent18) {
          (0, _inherits3.default)(_Child13, _Parent18);

          function _Child13() {
            (0, _classCallCheck3.default)(this, _Child13);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child13).apply(this, arguments));
          }

          return _Child13;
        }(Parent);

        Object.defineProperty(_Child13, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child14 = Parent.onInherited(_Child13);

            if (_Child14 !== void 0) {
              if (typeof _Child14 == 'function' && _Child14.name !== 'Child') {
                Object.defineProperty(_Child14, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child13 = _Child14;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child13;
      }();

      (0, _chai.expect)(Child).to.equal(replacement);
    });

    it("using anonymous class expressions with variable declaration", function () {
      var replacement = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            return replacement;
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child15 = function (_Parent19) {
          (0, _inherits3.default)(_Child15, _Parent19);

          function _Child15() {
            (0, _classCallCheck3.default)(this, _Child15);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child15).apply(this, arguments));
          }

          return _Child15;
        }(Parent);

        Object.defineProperty(_Child15, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child16 = Parent.onInherited(_Child15);

            if (_Child16 !== void 0) {
              if (typeof _Child16 == 'function' && _Child16.name !== 'Child') {
                Object.defineProperty(_Child16, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child15 = _Child16;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child15;
      }();

      (0, _chai.expect)(Child).to.equal(replacement);
    });

    it("using named class expressions saved as variables", function () {
      var replacement = _sinon2.default.spy();

      var Parent = function () {
        function NamedParent() {
          (0, _classCallCheck3.default)(this, NamedParent);
        }

        (0, _createClass3.default)(NamedParent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            return replacement;
          }
        }]);
        return NamedParent;
      }();

      var Child = function () {
        var _NamedChild13 = function (_Parent20) {
          (0, _inherits3.default)(_NamedChild13, _Parent20);

          function _NamedChild13() {
            (0, _classCallCheck3.default)(this, _NamedChild13);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild13).apply(this, arguments));
          }

          return _NamedChild13;
        }(Parent);

        Object.defineProperty(_NamedChild13, "name", {
          value: 'NamedChild',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _NamedChild14 = Parent.onInherited(_NamedChild13);

            if (_NamedChild14 !== void 0) {
              if (typeof _NamedChild14 == 'function' && _NamedChild14.name !== 'NamedChild') {
                Object.defineProperty(_NamedChild14, "name", {
                  value: 'NamedChild',
                  configurable: true
                });
              }

              _NamedChild13 = _NamedChild14;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NamedChild13;
      }();

      (0, _chai.expect)(Child).to.equal(replacement);
    });

    it("using anonymous class expressions on object literal properties", function () {
      var replacement = _sinon2.default.spy();

      var Parents = {
        Parent: function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return replacement;
            }
          }]);
          return Parent;
        }()
      };

      var Children = {
        Child: function () {
          var _temp11 = function (_Parents$Parent7) {
            (0, _inherits3.default)(_temp11, _Parents$Parent7);

            function _temp11() {
              (0, _classCallCheck3.default)(this, _temp11);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp11).apply(this, arguments));
            }

            return _temp11;
          }(Parents.Parent);

          Object.defineProperty(_temp11, "name", {
            value: 'class',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _temp12 = Parents.Parent.onInherited(_temp11);

              if (_temp12 !== void 0) {
                if (typeof _temp12 == 'function' && _temp12.name !== 'class') {
                  Object.defineProperty(_temp12, "name", {
                    value: 'class',
                    configurable: true
                  });
                }

                _temp11 = _temp12;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _temp11;
        }()
      };

      (0, _chai.expect)(Children.Child).to.equal(replacement);
    });

    it("using named class expressions on object literal properties", function () {
      var replacement = _sinon2.default.spy();

      var Parents = {
        Parent: function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return replacement;
            }
          }]);
          return NamedParent;
        }()
      };

      var Children = {
        Child: function () {
          var _NamedChild15 = function (_Parents$Parent8) {
            (0, _inherits3.default)(_NamedChild15, _Parents$Parent8);

            function _NamedChild15() {
              (0, _classCallCheck3.default)(this, _NamedChild15);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild15).apply(this, arguments));
            }

            return _NamedChild15;
          }(Parents.Parent);

          Object.defineProperty(_NamedChild15, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _NamedChild16 = Parents.Parent.onInherited(_NamedChild15);

              if (_NamedChild16 !== void 0) {
                if (typeof _NamedChild16 == 'function' && _NamedChild16.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild16, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild15 = _NamedChild16;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild15;
        }()
      };

      (0, _chai.expect)(Children.Child).to.equal(replacement);
    });
  });
  describe("can redefine the value of the declared class to a falsy value other than undefined", function () {
    describe("null", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return null;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child17 = function (_Parent21) {
            (0, _inherits3.default)(_Child17, _Parent21);

            function _Child17() {
              (0, _classCallCheck3.default)(this, _Child17);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child17).apply(this, arguments));
            }

            return _Child17;
          }(Parent);

          Object.defineProperty(_Child17, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child18 = Parent.onInherited(_Child17);

              if (_Child18 !== void 0) {
                if (typeof _Child18 == 'function' && _Child18.name !== 'Child') {
                  Object.defineProperty(_Child18, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child17 = _Child18;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child17;
        }();

        (0, _chai.expect)(Child).to.equal(null);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return null;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child19 = function (_Parent22) {
            (0, _inherits3.default)(_Child19, _Parent22);

            function _Child19() {
              (0, _classCallCheck3.default)(this, _Child19);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child19).apply(this, arguments));
            }

            return _Child19;
          }(Parent);

          Object.defineProperty(_Child19, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child20 = Parent.onInherited(_Child19);

              if (_Child20 !== void 0) {
                if (typeof _Child20 == 'function' && _Child20.name !== 'Child') {
                  Object.defineProperty(_Child20, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child19 = _Child20;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child19;
        }();

        (0, _chai.expect)(Child).to.equal(null);
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return null;
            }
          }]);
          return NamedParent;
        }();

        var Child = function () {
          var _NamedChild17 = function (_Parent23) {
            (0, _inherits3.default)(_NamedChild17, _Parent23);

            function _NamedChild17() {
              (0, _classCallCheck3.default)(this, _NamedChild17);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild17).apply(this, arguments));
            }

            return _NamedChild17;
          }(Parent);

          Object.defineProperty(_NamedChild17, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild18 = Parent.onInherited(_NamedChild17);

              if (_NamedChild18 !== void 0) {
                if (typeof _NamedChild18 == 'function' && _NamedChild18.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild18, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild17 = _NamedChild18;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild17;
        }();

        (0, _chai.expect)(Child).to.equal(null);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return null;
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp13 = function (_Parents$Parent9) {
              (0, _inherits3.default)(_temp13, _Parents$Parent9);

              function _temp13() {
                (0, _classCallCheck3.default)(this, _temp13);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp13).apply(this, arguments));
              }

              return _temp13;
            }(Parents.Parent);

            Object.defineProperty(_temp13, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp14 = Parents.Parent.onInherited(_temp13);

                if (_temp14 !== void 0) {
                  if (typeof _temp14 == 'function' && _temp14.name !== 'class') {
                    Object.defineProperty(_temp14, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp13 = _temp14;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp13;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal(null);
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return null;
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild19 = function (_Parents$Parent10) {
              (0, _inherits3.default)(_NamedChild19, _Parents$Parent10);

              function _NamedChild19() {
                (0, _classCallCheck3.default)(this, _NamedChild19);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild19).apply(this, arguments));
              }

              return _NamedChild19;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild19, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild20 = Parents.Parent.onInherited(_NamedChild19);

                if (_NamedChild20 !== void 0) {
                  if (typeof _NamedChild20 == 'function' && _NamedChild20.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild20, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild19 = _NamedChild20;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild19;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal(null);
      });
    });
    describe("0", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return 0;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child21 = function (_Parent24) {
            (0, _inherits3.default)(_Child21, _Parent24);

            function _Child21() {
              (0, _classCallCheck3.default)(this, _Child21);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child21).apply(this, arguments));
            }

            return _Child21;
          }(Parent);

          Object.defineProperty(_Child21, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child22 = Parent.onInherited(_Child21);

              if (_Child22 !== void 0) {
                if (typeof _Child22 == 'function' && _Child22.name !== 'Child') {
                  Object.defineProperty(_Child22, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child21 = _Child22;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child21;
        }();

        (0, _chai.expect)(Child).to.equal(0);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return 0;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child23 = function (_Parent25) {
            (0, _inherits3.default)(_Child23, _Parent25);

            function _Child23() {
              (0, _classCallCheck3.default)(this, _Child23);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child23).apply(this, arguments));
            }

            return _Child23;
          }(Parent);

          Object.defineProperty(_Child23, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child24 = Parent.onInherited(_Child23);

              if (_Child24 !== void 0) {
                if (typeof _Child24 == 'function' && _Child24.name !== 'Child') {
                  Object.defineProperty(_Child24, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child23 = _Child24;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child23;
        }();

        (0, _chai.expect)(Child).to.equal(0);
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return 0;
            }
          }]);
          return NamedParent;
        }();

        var Child = function () {
          var _NamedChild21 = function (_Parent26) {
            (0, _inherits3.default)(_NamedChild21, _Parent26);

            function _NamedChild21() {
              (0, _classCallCheck3.default)(this, _NamedChild21);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild21).apply(this, arguments));
            }

            return _NamedChild21;
          }(Parent);

          Object.defineProperty(_NamedChild21, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild22 = Parent.onInherited(_NamedChild21);

              if (_NamedChild22 !== void 0) {
                if (typeof _NamedChild22 == 'function' && _NamedChild22.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild22, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild21 = _NamedChild22;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild21;
        }();

        (0, _chai.expect)(Child).to.equal(0);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return 0;
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp15 = function (_Parents$Parent11) {
              (0, _inherits3.default)(_temp15, _Parents$Parent11);

              function _temp15() {
                (0, _classCallCheck3.default)(this, _temp15);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp15).apply(this, arguments));
              }

              return _temp15;
            }(Parents.Parent);

            Object.defineProperty(_temp15, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp16 = Parents.Parent.onInherited(_temp15);

                if (_temp16 !== void 0) {
                  if (typeof _temp16 == 'function' && _temp16.name !== 'class') {
                    Object.defineProperty(_temp16, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp15 = _temp16;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp15;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal(0);
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return 0;
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild23 = function (_Parents$Parent12) {
              (0, _inherits3.default)(_NamedChild23, _Parents$Parent12);

              function _NamedChild23() {
                (0, _classCallCheck3.default)(this, _NamedChild23);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild23).apply(this, arguments));
              }

              return _NamedChild23;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild23, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild24 = Parents.Parent.onInherited(_NamedChild23);

                if (_NamedChild24 !== void 0) {
                  if (typeof _NamedChild24 == 'function' && _NamedChild24.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild24, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild23 = _NamedChild24;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild23;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal(0);
      });
    });
    describe("\"\" (empty string)", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return "";
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child25 = function (_Parent27) {
            (0, _inherits3.default)(_Child25, _Parent27);

            function _Child25() {
              (0, _classCallCheck3.default)(this, _Child25);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child25).apply(this, arguments));
            }

            return _Child25;
          }(Parent);

          Object.defineProperty(_Child25, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child26 = Parent.onInherited(_Child25);

              if (_Child26 !== void 0) {
                if (typeof _Child26 == 'function' && _Child26.name !== 'Child') {
                  Object.defineProperty(_Child26, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child25 = _Child26;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child25;
        }();

        (0, _chai.expect)(Child).to.equal("");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return "";
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child27 = function (_Parent28) {
            (0, _inherits3.default)(_Child27, _Parent28);

            function _Child27() {
              (0, _classCallCheck3.default)(this, _Child27);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child27).apply(this, arguments));
            }

            return _Child27;
          }(Parent);

          Object.defineProperty(_Child27, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child28 = Parent.onInherited(_Child27);

              if (_Child28 !== void 0) {
                if (typeof _Child28 == 'function' && _Child28.name !== 'Child') {
                  Object.defineProperty(_Child28, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child27 = _Child28;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child27;
        }();

        (0, _chai.expect)(Child).to.equal("");
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return "";
            }
          }]);
          return NamedParent;
        }();

        var Child = function () {
          var _NamedChild25 = function (_Parent29) {
            (0, _inherits3.default)(_NamedChild25, _Parent29);

            function _NamedChild25() {
              (0, _classCallCheck3.default)(this, _NamedChild25);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild25).apply(this, arguments));
            }

            return _NamedChild25;
          }(Parent);

          Object.defineProperty(_NamedChild25, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild26 = Parent.onInherited(_NamedChild25);

              if (_NamedChild26 !== void 0) {
                if (typeof _NamedChild26 == 'function' && _NamedChild26.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild26, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild25 = _NamedChild26;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild25;
        }();

        (0, _chai.expect)(Child).to.equal("");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return "";
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp17 = function (_Parents$Parent13) {
              (0, _inherits3.default)(_temp17, _Parents$Parent13);

              function _temp17() {
                (0, _classCallCheck3.default)(this, _temp17);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp17).apply(this, arguments));
              }

              return _temp17;
            }(Parents.Parent);

            Object.defineProperty(_temp17, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp18 = Parents.Parent.onInherited(_temp17);

                if (_temp18 !== void 0) {
                  if (typeof _temp18 == 'function' && _temp18.name !== 'class') {
                    Object.defineProperty(_temp18, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp17 = _temp18;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp17;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal("");
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return "";
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild27 = function (_Parents$Parent14) {
              (0, _inherits3.default)(_NamedChild27, _Parents$Parent14);

              function _NamedChild27() {
                (0, _classCallCheck3.default)(this, _NamedChild27);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild27).apply(this, arguments));
              }

              return _NamedChild27;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild27, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild28 = Parents.Parent.onInherited(_NamedChild27);

                if (_NamedChild28 !== void 0) {
                  if (typeof _NamedChild28 == 'function' && _NamedChild28.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild28, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild27 = _NamedChild28;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild27;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal("");
      });
    });
    describe("false", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return false;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child29 = function (_Parent30) {
            (0, _inherits3.default)(_Child29, _Parent30);

            function _Child29() {
              (0, _classCallCheck3.default)(this, _Child29);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child29).apply(this, arguments));
            }

            return _Child29;
          }(Parent);

          Object.defineProperty(_Child29, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child30 = Parent.onInherited(_Child29);

              if (_Child30 !== void 0) {
                if (typeof _Child30 == 'function' && _Child30.name !== 'Child') {
                  Object.defineProperty(_Child30, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child29 = _Child30;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child29;
        }();

        (0, _chai.expect)(Child).to.equal(false);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return false;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child31 = function (_Parent31) {
            (0, _inherits3.default)(_Child31, _Parent31);

            function _Child31() {
              (0, _classCallCheck3.default)(this, _Child31);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child31).apply(this, arguments));
            }

            return _Child31;
          }(Parent);

          Object.defineProperty(_Child31, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child32 = Parent.onInherited(_Child31);

              if (_Child32 !== void 0) {
                if (typeof _Child32 == 'function' && _Child32.name !== 'Child') {
                  Object.defineProperty(_Child32, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child31 = _Child32;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child31;
        }();

        (0, _chai.expect)(Child).to.equal(false);
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return false;
            }
          }]);
          return NamedParent;
        }();

        var Child = function () {
          var _NamedChild29 = function (_Parent32) {
            (0, _inherits3.default)(_NamedChild29, _Parent32);

            function _NamedChild29() {
              (0, _classCallCheck3.default)(this, _NamedChild29);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild29).apply(this, arguments));
            }

            return _NamedChild29;
          }(Parent);

          Object.defineProperty(_NamedChild29, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild30 = Parent.onInherited(_NamedChild29);

              if (_NamedChild30 !== void 0) {
                if (typeof _NamedChild30 == 'function' && _NamedChild30.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild30, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild29 = _NamedChild30;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild29;
        }();

        (0, _chai.expect)(Child).to.equal(false);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return false;
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp19 = function (_Parents$Parent15) {
              (0, _inherits3.default)(_temp19, _Parents$Parent15);

              function _temp19() {
                (0, _classCallCheck3.default)(this, _temp19);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp19).apply(this, arguments));
              }

              return _temp19;
            }(Parents.Parent);

            Object.defineProperty(_temp19, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp20 = Parents.Parent.onInherited(_temp19);

                if (_temp20 !== void 0) {
                  if (typeof _temp20 == 'function' && _temp20.name !== 'class') {
                    Object.defineProperty(_temp20, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp19 = _temp20;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp19;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal(false);
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return false;
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild31 = function (_Parents$Parent16) {
              (0, _inherits3.default)(_NamedChild31, _Parents$Parent16);

              function _NamedChild31() {
                (0, _classCallCheck3.default)(this, _NamedChild31);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild31).apply(this, arguments));
              }

              return _NamedChild31;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild31, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild32 = Parents.Parent.onInherited(_NamedChild31);

                if (_NamedChild32 !== void 0) {
                  if (typeof _NamedChild32 == 'function' && _NamedChild32.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild32, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild31 = _NamedChild32;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild31;
          }()
        };

        (0, _chai.expect)(Children.Child).to.equal(false);
      });
    });
    describe("NaN", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return NaN;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child33 = function (_Parent33) {
            (0, _inherits3.default)(_Child33, _Parent33);

            function _Child33() {
              (0, _classCallCheck3.default)(this, _Child33);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child33).apply(this, arguments));
            }

            return _Child33;
          }(Parent);

          Object.defineProperty(_Child33, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child34 = Parent.onInherited(_Child33);

              if (_Child34 !== void 0) {
                if (typeof _Child34 == 'function' && _Child34.name !== 'Child') {
                  Object.defineProperty(_Child34, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child33 = _Child34;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child33;
        }();

        (0, _chai.expect)(Child).to.be.NaN;
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return NaN;
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child35 = function (_Parent34) {
            (0, _inherits3.default)(_Child35, _Parent34);

            function _Child35() {
              (0, _classCallCheck3.default)(this, _Child35);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child35).apply(this, arguments));
            }

            return _Child35;
          }(Parent);

          Object.defineProperty(_Child35, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child36 = Parent.onInherited(_Child35);

              if (_Child36 !== void 0) {
                if (typeof _Child36 == 'function' && _Child36.name !== 'Child') {
                  Object.defineProperty(_Child36, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child35 = _Child36;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child35;
        }();

        (0, _chai.expect)(Child).to.be.NaN;
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return NaN;
            }
          }]);
          return NamedParent;
        }();

        var Child = function () {
          var _NamedChild33 = function (_Parent35) {
            (0, _inherits3.default)(_NamedChild33, _Parent35);

            function _NamedChild33() {
              (0, _classCallCheck3.default)(this, _NamedChild33);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild33).apply(this, arguments));
            }

            return _NamedChild33;
          }(Parent);

          Object.defineProperty(_NamedChild33, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild34 = Parent.onInherited(_NamedChild33);

              if (_NamedChild34 !== void 0) {
                if (typeof _NamedChild34 == 'function' && _NamedChild34.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild34, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild33 = _NamedChild34;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild33;
        }();

        (0, _chai.expect)(Child).to.be.NaN;
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return NaN;
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp21 = function (_Parents$Parent17) {
              (0, _inherits3.default)(_temp21, _Parents$Parent17);

              function _temp21() {
                (0, _classCallCheck3.default)(this, _temp21);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp21).apply(this, arguments));
              }

              return _temp21;
            }(Parents.Parent);

            Object.defineProperty(_temp21, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp22 = Parents.Parent.onInherited(_temp21);

                if (_temp22 !== void 0) {
                  if (typeof _temp22 == 'function' && _temp22.name !== 'class') {
                    Object.defineProperty(_temp22, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp21 = _temp22;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp21;
          }()
        };

        (0, _chai.expect)(Children.Child).to.be.NaN;
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {
                return NaN;
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild35 = function (_Parents$Parent18) {
              (0, _inherits3.default)(_NamedChild35, _Parents$Parent18);

              function _NamedChild35() {
                (0, _classCallCheck3.default)(this, _NamedChild35);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild35).apply(this, arguments));
              }

              return _NamedChild35;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild35, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild36 = Parents.Parent.onInherited(_NamedChild35);

                if (_NamedChild36 !== void 0) {
                  if (typeof _NamedChild36 == 'function' && _NamedChild36.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild36, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild35 = _NamedChild36;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild35;
          }()
        };

        (0, _chai.expect)(Children.Child).to.be.NaN;
      });
    });
  });
  describe("can not redefine the value of the declared class by returning undefined", function () {
    it("using named class declarations", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            return undefined;
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child37 = function (_Parent36) {
          (0, _inherits3.default)(_Child37, _Parent36);

          function _Child37() {
            (0, _classCallCheck3.default)(this, _Child37);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child37).apply(this, arguments));
          }

          return _Child37;
        }(Parent);

        Object.defineProperty(_Child37, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child38 = Parent.onInherited(_Child37);

            if (_Child38 !== void 0) {
              if (typeof _Child38 == 'function' && _Child38.name !== 'Child') {
                Object.defineProperty(_Child38, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child37 = _Child38;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child37;
      }();

      (0, _chai.expect)(Child).not.to.be.undefined;
    });

    it("using anonymous class expressions with variable declaration", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            return undefined;
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child39 = function (_Parent37) {
          (0, _inherits3.default)(_Child39, _Parent37);

          function _Child39() {
            (0, _classCallCheck3.default)(this, _Child39);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child39).apply(this, arguments));
          }

          return _Child39;
        }(Parent);

        Object.defineProperty(_Child39, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child40 = Parent.onInherited(_Child39);

            if (_Child40 !== void 0) {
              if (typeof _Child40 == 'function' && _Child40.name !== 'Child') {
                Object.defineProperty(_Child40, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child39 = _Child40;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child39;
      }();

      (0, _chai.expect)(Child).not.to.be.undefined;
    });

    it("using named class expressions saved as variables", function () {
      var Parent = function () {
        function NamedParent() {
          (0, _classCallCheck3.default)(this, NamedParent);
        }

        (0, _createClass3.default)(NamedParent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            return undefined;
          }
        }]);
        return NamedParent;
      }();

      var Child = function () {
        var _NamedChild37 = function (_Parent38) {
          (0, _inherits3.default)(_NamedChild37, _Parent38);

          function _NamedChild37() {
            (0, _classCallCheck3.default)(this, _NamedChild37);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild37).apply(this, arguments));
          }

          return _NamedChild37;
        }(Parent);

        Object.defineProperty(_NamedChild37, "name", {
          value: 'NamedChild',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _NamedChild38 = Parent.onInherited(_NamedChild37);

            if (_NamedChild38 !== void 0) {
              if (typeof _NamedChild38 == 'function' && _NamedChild38.name !== 'NamedChild') {
                Object.defineProperty(_NamedChild38, "name", {
                  value: 'NamedChild',
                  configurable: true
                });
              }

              _NamedChild37 = _NamedChild38;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NamedChild37;
      }();

      (0, _chai.expect)(Child).not.to.be.undefined;
    });

    it("using anonymous class expressions on object literal properties", function () {
      var Parents = {
        Parent: function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return undefined;
            }
          }]);
          return Parent;
        }()
      };

      var Children = {
        Child: function () {
          var _temp23 = function (_Parents$Parent19) {
            (0, _inherits3.default)(_temp23, _Parents$Parent19);

            function _temp23() {
              (0, _classCallCheck3.default)(this, _temp23);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp23).apply(this, arguments));
            }

            return _temp23;
          }(Parents.Parent);

          Object.defineProperty(_temp23, "name", {
            value: 'class',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _temp24 = Parents.Parent.onInherited(_temp23);

              if (_temp24 !== void 0) {
                if (typeof _temp24 == 'function' && _temp24.name !== 'class') {
                  Object.defineProperty(_temp24, "name", {
                    value: 'class',
                    configurable: true
                  });
                }

                _temp23 = _temp24;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _temp23;
        }()
      };

      (0, _chai.expect)(Children.Child).not.to.be.undefined;
    });

    it("using named class expressions on object literal properties", function () {
      var Parents = {
        Parent: function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {
              return undefined;
            }
          }]);
          return NamedParent;
        }()
      };

      var Children = {
        Child: function () {
          var _NamedChild39 = function (_Parents$Parent20) {
            (0, _inherits3.default)(_NamedChild39, _Parents$Parent20);

            function _NamedChild39() {
              (0, _classCallCheck3.default)(this, _NamedChild39);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild39).apply(this, arguments));
            }

            return _NamedChild39;
          }(Parents.Parent);

          Object.defineProperty(_NamedChild39, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parents.Parent) {
            if (typeof Parents.Parent.onInherited == 'function') {
              var _NamedChild40 = Parents.Parent.onInherited(_NamedChild39);

              if (_NamedChild40 !== void 0) {
                if (typeof _NamedChild40 == 'function' && _NamedChild40.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild40, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild39 = _NamedChild40;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild39;
        }()
      };

      (0, _chai.expect)(Children.Child).not.to.be.undefined;
    });
  });
});

describe("A class", function () {
  describe("with no parent", function () {
    describe("has a reliable name property", function () {
      it("using named class declarations", function () {
        var Thing = function Thing() {
          (0, _classCallCheck3.default)(this, Thing);
        };

        (0, _chai.expect)(Thing.name).to.equal("Thing");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Thing = function Thing() {
          (0, _classCallCheck3.default)(this, Thing);
        };
        (0, _chai.expect)(Thing.name).to.equal("Thing");
      });

      it("using named class expressions saved as variables", function () {
        var Thing = function NamedThing() {
          (0, _classCallCheck3.default)(this, NamedThing);
        };
        (0, _chai.expect)(Thing.name).to.equal("NamedThing");
      });

      it("using named class expressions on object literal properties", function () {
        var Things = {
          Thing: function NamedThing() {
            (0, _classCallCheck3.default)(this, NamedThing);
          }
        };
        (0, _chai.expect)(Things.Thing.name).to.equal("NamedThing");
      });
    });
    describe("can have static methods", function () {
      it("using named class declarations", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, null, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return Thing;
        }();

        (0, _chai.expect)(Thing.coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, null, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return Thing;
        }();
        (0, _chai.expect)(Thing.coolnessFactor()).to.equal(5);
      });

      it("using named class expressions saved as variables", function () {
        var Thing = function () {
          function NamedThing() {
            (0, _classCallCheck3.default)(this, NamedThing);
          }

          (0, _createClass3.default)(NamedThing, null, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return NamedThing;
        }();
        (0, _chai.expect)(Thing.coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function Thing() {
              (0, _classCallCheck3.default)(this, Thing);
            }

            (0, _createClass3.default)(Thing, null, [{
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }]);
            return Thing;
          }()
        };
        (0, _chai.expect)(Things.Thing.coolnessFactor()).to.equal(5);
      });

      it("using named class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function NamedThing() {
              (0, _classCallCheck3.default)(this, NamedThing);
            }

            (0, _createClass3.default)(NamedThing, null, [{
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }]);
            return NamedThing;
          }()
        };
        (0, _chai.expect)(Things.Thing.coolnessFactor()).to.equal(5);
      });
    });
    describe("can have instance methods", function () {
      it("using named class declarations", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return Thing;
        }();

        (0, _chai.expect)(new Thing().coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return Thing;
        }();
        (0, _chai.expect)(new Thing().coolnessFactor()).to.equal(5);
      });

      it("using named class expressions saved as variables", function () {
        var Thing = function () {
          function NamedThing() {
            (0, _classCallCheck3.default)(this, NamedThing);
          }

          (0, _createClass3.default)(NamedThing, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return NamedThing;
        }();
        (0, _chai.expect)(new Thing().coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function Thing() {
              (0, _classCallCheck3.default)(this, Thing);
            }

            (0, _createClass3.default)(Thing, [{
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }]);
            return Thing;
          }()
        };
        (0, _chai.expect)(new Things.Thing().coolnessFactor()).to.equal(5);
      });

      it("using named class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function NamedThing() {
              (0, _classCallCheck3.default)(this, NamedThing);
            }

            (0, _createClass3.default)(NamedThing, [{
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }]);
            return NamedThing;
          }()
        };
        (0, _chai.expect)(new Things.Thing().coolnessFactor()).to.equal(5);
      });
    });
  });
  describe("with no parent that defines a static onInherited method", function () {
    describe("has a reliable name property", function () {
      it("using named class declarations", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Thing;
        }();

        (0, _chai.expect)(Thing.name).to.equal("Thing");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Thing;
        }();
        (0, _chai.expect)(Thing.name).to.equal("Thing");
      });

      it("using named class expressions saved as variables", function () {
        var Thing = function () {
          function NamedThing() {
            (0, _classCallCheck3.default)(this, NamedThing);
          }

          (0, _createClass3.default)(NamedThing, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedThing;
        }();
        (0, _chai.expect)(Thing.name).to.equal("NamedThing");
      });

      it("using named class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function NamedThing() {
              (0, _classCallCheck3.default)(this, NamedThing);
            }

            (0, _createClass3.default)(NamedThing, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedThing;
          }()
        };
        (0, _chai.expect)(Things.Thing.name).to.equal("NamedThing");
      });
    });
    describe("can have static methods", function () {
      it("using named class declarations", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return Thing;
        }();

        (0, _chai.expect)(Thing.coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return Thing;
        }();
        (0, _chai.expect)(Thing.coolnessFactor()).to.equal(5);
      });

      it("using named class expressions saved as variables", function () {
        var Thing = function () {
          function NamedThing() {
            (0, _classCallCheck3.default)(this, NamedThing);
          }

          (0, _createClass3.default)(NamedThing, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }]);
          return NamedThing;
        }();
        (0, _chai.expect)(Thing.coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function Thing() {
              (0, _classCallCheck3.default)(this, Thing);
            }

            (0, _createClass3.default)(Thing, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }, {
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }]);
            return Thing;
          }()
        };
        (0, _chai.expect)(Things.Thing.coolnessFactor()).to.equal(5);
      });

      it("using named class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function NamedThing() {
              (0, _classCallCheck3.default)(this, NamedThing);
            }

            (0, _createClass3.default)(NamedThing, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }, {
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }]);
            return NamedThing;
          }()
        };
        (0, _chai.expect)(Things.Thing.coolnessFactor()).to.equal(5);
      });
    });
    describe("can have instance methods", function () {
      it("using named class declarations", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Thing;
        }();

        (0, _chai.expect)(new Thing().coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Thing = function () {
          function Thing() {
            (0, _classCallCheck3.default)(this, Thing);
          }

          (0, _createClass3.default)(Thing, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Thing;
        }();
        (0, _chai.expect)(new Thing().coolnessFactor()).to.equal(5);
      });

      it("using named class expressions saved as variables", function () {
        var Thing = function () {
          function NamedThing() {
            (0, _classCallCheck3.default)(this, NamedThing);
          }

          (0, _createClass3.default)(NamedThing, [{
            key: 'coolnessFactor',
            value: function coolnessFactor() {
              return 5;
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedThing;
        }();
        (0, _chai.expect)(new Thing().coolnessFactor()).to.equal(5);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function Thing() {
              (0, _classCallCheck3.default)(this, Thing);
            }

            (0, _createClass3.default)(Thing, [{
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }], [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Thing;
          }()
        };
        (0, _chai.expect)(new Things.Thing().coolnessFactor()).to.equal(5);
      });

      it("using named class expressions on object literal properties", function () {
        var Things = {
          Thing: function () {
            function NamedThing() {
              (0, _classCallCheck3.default)(this, NamedThing);
            }

            (0, _createClass3.default)(NamedThing, [{
              key: 'coolnessFactor',
              value: function coolnessFactor() {
                return 5;
              }
            }], [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedThing;
          }()
        };
        (0, _chai.expect)(new Things.Thing().coolnessFactor()).to.equal(5);
      });
    });
  });
  describe("with a parent", function () {
    describe("has a reliable name property", function () {
      it("using named class declarations", function () {
        var Parent = function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        };

        var Child = function () {
          var _Child41 = function (_Parent39) {
            (0, _inherits3.default)(_Child41, _Parent39);

            function _Child41() {
              (0, _classCallCheck3.default)(this, _Child41);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child41).apply(this, arguments));
            }

            return _Child41;
          }(Parent);

          Object.defineProperty(_Child41, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child42 = Parent.onInherited(_Child41);

              if (_Child42 !== void 0) {
                if (typeof _Child42 == 'function' && _Child42.name !== 'Child') {
                  Object.defineProperty(_Child42, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child41 = _Child42;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child41;
        }();

        (0, _chai.expect)(Child.name).to.equal("Child");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        };
        var Child = function () {
          var _Child43 = function (_Parent40) {
            (0, _inherits3.default)(_Child43, _Parent40);

            function _Child43() {
              (0, _classCallCheck3.default)(this, _Child43);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child43).apply(this, arguments));
            }

            return _Child43;
          }(Parent);

          Object.defineProperty(_Child43, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child44 = Parent.onInherited(_Child43);

              if (_Child44 !== void 0) {
                if (typeof _Child44 == 'function' && _Child44.name !== 'Child') {
                  Object.defineProperty(_Child44, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child43 = _Child44;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child43;
        }();
        (0, _chai.expect)(Child.name).to.equal("Child");
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function NamedParent() {
          (0, _classCallCheck3.default)(this, NamedParent);
        };
        var Child = function () {
          var _NamedChild41 = function (_Parent41) {
            (0, _inherits3.default)(_NamedChild41, _Parent41);

            function _NamedChild41() {
              (0, _classCallCheck3.default)(this, _NamedChild41);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild41).apply(this, arguments));
            }

            return _NamedChild41;
          }(Parent);

          Object.defineProperty(_NamedChild41, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild42 = Parent.onInherited(_NamedChild41);

              if (_NamedChild42 !== void 0) {
                if (typeof _NamedChild42 == 'function' && _NamedChild42.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild42, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild41 = _NamedChild42;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild41;
        }();
        (0, _chai.expect)(Child.name).to.equal("NamedChild");
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }
        };

        var Children = {
          Child: function () {
            var _NamedChild43 = function (_Parents$Parent21) {
              (0, _inherits3.default)(_NamedChild43, _Parents$Parent21);

              function _NamedChild43() {
                (0, _classCallCheck3.default)(this, _NamedChild43);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild43).apply(this, arguments));
              }

              return _NamedChild43;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild43, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild44 = Parents.Parent.onInherited(_NamedChild43);

                if (_NamedChild44 !== void 0) {
                  if (typeof _NamedChild44 == 'function' && _NamedChild44.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild44, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild43 = _NamedChild44;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild43;
          }()
        };
        (0, _chai.expect)(Children.Child.name).to.equal("NamedChild");
      });
    });
    describe("can have static methods", function () {
      it("using named class declarations", function () {
        var Parent = function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        };

        var Child = function () {
          var _Child45 = function (_Parent42) {
            (0, _inherits3.default)(_Child45, _Parent42);

            function _Child45() {
              (0, _classCallCheck3.default)(this, _Child45);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child45).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child45, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child45;
          }(Parent);

          Object.defineProperty(_Child45, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child46 = Parent.onInherited(_Child45);

              if (_Child46 !== void 0) {
                if (typeof _Child46 == 'function' && _Child46.name !== 'Child') {
                  Object.defineProperty(_Child46, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child45 = _Child46;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child45;
        }();

        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        };
        var Child = function () {
          var _Child47 = function (_Parent43) {
            (0, _inherits3.default)(_Child47, _Parent43);

            function _Child47() {
              (0, _classCallCheck3.default)(this, _Child47);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child47).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child47, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child47;
          }(Parent);

          Object.defineProperty(_Child47, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child48 = Parent.onInherited(_Child47);

              if (_Child48 !== void 0) {
                if (typeof _Child48 == 'function' && _Child48.name !== 'Child') {
                  Object.defineProperty(_Child48, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child47 = _Child48;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child47;
        }();
        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function NamedParent() {
          (0, _classCallCheck3.default)(this, NamedParent);
        };
        var Child = function () {
          var _NamedChild45 = function (_Parent44) {
            (0, _inherits3.default)(_NamedChild45, _Parent44);

            function _NamedChild45() {
              (0, _classCallCheck3.default)(this, _NamedChild45);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild45).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedChild45, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _NamedChild45;
          }(Parent);

          Object.defineProperty(_NamedChild45, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild46 = Parent.onInherited(_NamedChild45);

              if (_NamedChild46 !== void 0) {
                if (typeof _NamedChild46 == 'function' && _NamedChild46.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild46, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild45 = _NamedChild46;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild45;
        }();
        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }
        };

        var Children = {
          Child: function () {
            var _temp25 = function (_Parents$Parent22) {
              (0, _inherits3.default)(_temp25, _Parents$Parent22);

              function _temp25() {
                (0, _classCallCheck3.default)(this, _temp25);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp25).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp25, null, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _temp25;
            }(Parents.Parent);

            Object.defineProperty(_temp25, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp26 = Parents.Parent.onInherited(_temp25);

                if (_temp26 !== void 0) {
                  if (typeof _temp26 == 'function' && _temp26.name !== 'class') {
                    Object.defineProperty(_temp26, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp25 = _temp26;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp25;
          }()
        };
        (0, _chai.expect)(Children.Child.childishness()).to.equal(6);
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }
        };

        var Children = {
          Child: function () {
            var _NamedChild47 = function (_Parents$Parent23) {
              (0, _inherits3.default)(_NamedChild47, _Parents$Parent23);

              function _NamedChild47() {
                (0, _classCallCheck3.default)(this, _NamedChild47);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild47).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedChild47, null, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _NamedChild47;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild47, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild48 = Parents.Parent.onInherited(_NamedChild47);

                if (_NamedChild48 !== void 0) {
                  if (typeof _NamedChild48 == 'function' && _NamedChild48.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild48, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild47 = _NamedChild48;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild47;
          }()
        };
        (0, _chai.expect)(Children.Child.childishness()).to.equal(6);
      });
    });
    describe("can inherit static methods from its parent", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child49 = function (_Parent45) {
            (0, _inherits3.default)(_Child49, _Parent45);

            function _Child49() {
              (0, _classCallCheck3.default)(this, _Child49);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child49).apply(this, arguments));
            }

            return _Child49;
          }(Parent);

          Object.defineProperty(_Child49, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child50 = Parent.onInherited(_Child49);

              if (_Child50 !== void 0) {
                if (typeof _Child50 == 'function' && _Child50.name !== 'Child') {
                  Object.defineProperty(_Child50, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child49 = _Child50;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child49;
        }();

        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Parent;
        }();
        var Child = function () {
          var _Child51 = function (_Parent46) {
            (0, _inherits3.default)(_Child51, _Parent46);

            function _Child51() {
              (0, _classCallCheck3.default)(this, _Child51);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child51).apply(this, arguments));
            }

            return _Child51;
          }(Parent);

          Object.defineProperty(_Child51, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child52 = Parent.onInherited(_Child51);

              if (_Child52 !== void 0) {
                if (typeof _Child52 == 'function' && _Child52.name !== 'Child') {
                  Object.defineProperty(_Child52, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child51 = _Child52;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child51;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return NamedParent;
        }();
        var Child = function () {
          var _NamedChild49 = function (_Parent47) {
            (0, _inherits3.default)(_NamedChild49, _Parent47);

            function _NamedChild49() {
              (0, _classCallCheck3.default)(this, _NamedChild49);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild49).apply(this, arguments));
            }

            return _NamedChild49;
          }(Parent);

          Object.defineProperty(_NamedChild49, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild50 = Parent.onInherited(_NamedChild49);

              if (_NamedChild50 !== void 0) {
                if (typeof _NamedChild50 == 'function' && _NamedChild50.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild50, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild49 = _NamedChild50;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild49;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp27 = function (_Parents$Parent24) {
              (0, _inherits3.default)(_temp27, _Parents$Parent24);

              function _temp27() {
                (0, _classCallCheck3.default)(this, _temp27);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp27).apply(this, arguments));
              }

              return _temp27;
            }(Parents.Parent);

            Object.defineProperty(_temp27, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp28 = Parents.Parent.onInherited(_temp27);

                if (_temp28 !== void 0) {
                  if (typeof _temp28 == 'function' && _temp28.name !== 'class') {
                    Object.defineProperty(_temp28, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp27 = _temp28;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp27;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild51 = function (_Parents$Parent25) {
              (0, _inherits3.default)(_NamedChild51, _Parents$Parent25);

              function _NamedChild51() {
                (0, _classCallCheck3.default)(this, _NamedChild51);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild51).apply(this, arguments));
              }

              return _NamedChild51;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild51, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild52 = Parents.Parent.onInherited(_NamedChild51);

                if (_NamedChild52 !== void 0) {
                  if (typeof _NamedChild52 == 'function' && _NamedChild52.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild52, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild51 = _NamedChild52;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild51;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });
    });
    describe("can have instance methods", function () {
      it("using named class declarations", function () {
        var Parent = function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        };

        var Child = function () {
          var _Child53 = function (_Parent48) {
            (0, _inherits3.default)(_Child53, _Parent48);

            function _Child53() {
              (0, _classCallCheck3.default)(this, _Child53);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child53).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child53, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child53;
          }(Parent);

          Object.defineProperty(_Child53, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child54 = Parent.onInherited(_Child53);

              if (_Child54 !== void 0) {
                if (typeof _Child54 == 'function' && _Child54.name !== 'Child') {
                  Object.defineProperty(_Child54, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child53 = _Child54;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child53;
        }();

        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        };
        var Child = function () {
          var _Child55 = function (_Parent49) {
            (0, _inherits3.default)(_Child55, _Parent49);

            function _Child55() {
              (0, _classCallCheck3.default)(this, _Child55);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child55).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child55, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child55;
          }(Parent);

          Object.defineProperty(_Child55, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child56 = Parent.onInherited(_Child55);

              if (_Child56 !== void 0) {
                if (typeof _Child56 == 'function' && _Child56.name !== 'Child') {
                  Object.defineProperty(_Child56, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child55 = _Child56;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child55;
        }();
        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function NamedParent() {
          (0, _classCallCheck3.default)(this, NamedParent);
        };
        var Child = function () {
          var _NamedChild53 = function (_Parent50) {
            (0, _inherits3.default)(_NamedChild53, _Parent50);

            function _NamedChild53() {
              (0, _classCallCheck3.default)(this, _NamedChild53);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild53).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedChild53, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _NamedChild53;
          }(Parent);

          Object.defineProperty(_NamedChild53, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild54 = Parent.onInherited(_NamedChild53);

              if (_NamedChild54 !== void 0) {
                if (typeof _NamedChild54 == 'function' && _NamedChild54.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild54, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild53 = _NamedChild54;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild53;
        }();
        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }
        };

        var Children = {
          Child: function () {
            var _temp29 = function (_Parents$Parent26) {
              (0, _inherits3.default)(_temp29, _Parents$Parent26);

              function _temp29() {
                (0, _classCallCheck3.default)(this, _temp29);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp29).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp29, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _temp29;
            }(Parents.Parent);

            Object.defineProperty(_temp29, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp30 = Parents.Parent.onInherited(_temp29);

                if (_temp30 !== void 0) {
                  if (typeof _temp30 == 'function' && _temp30.name !== 'class') {
                    Object.defineProperty(_temp30, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp29 = _temp30;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp29;
          }()
        };
        (0, _chai.expect)(new Children.Child().childishness()).to.equal(6);
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }
        };

        var Children = {
          Child: function () {
            var _NamedChild55 = function (_Parents$Parent27) {
              (0, _inherits3.default)(_NamedChild55, _Parents$Parent27);

              function _NamedChild55() {
                (0, _classCallCheck3.default)(this, _NamedChild55);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild55).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedChild55, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _NamedChild55;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild55, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild56 = Parents.Parent.onInherited(_NamedChild55);

                if (_NamedChild56 !== void 0) {
                  if (typeof _NamedChild56 == 'function' && _NamedChild56.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild56, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild55 = _NamedChild56;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild55;
          }()
        };
        (0, _chai.expect)(new Children.Child().childishness()).to.equal(6);
      });
    });
    describe("can inherit instance methods from its parent", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child57 = function (_Parent51) {
            (0, _inherits3.default)(_Child57, _Parent51);

            function _Child57() {
              (0, _classCallCheck3.default)(this, _Child57);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child57).apply(this, arguments));
            }

            return _Child57;
          }(Parent);

          Object.defineProperty(_Child57, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child58 = Parent.onInherited(_Child57);

              if (_Child58 !== void 0) {
                if (typeof _Child58 == 'function' && _Child58.name !== 'Child') {
                  Object.defineProperty(_Child58, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child57 = _Child58;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child57;
        }();

        (0, _chai.expect)(new Child().eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Parent;
        }();
        var Child = function () {
          var _Child59 = function (_Parent52) {
            (0, _inherits3.default)(_Child59, _Parent52);

            function _Child59() {
              (0, _classCallCheck3.default)(this, _Child59);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child59).apply(this, arguments));
            }

            return _Child59;
          }(Parent);

          Object.defineProperty(_Child59, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child60 = Parent.onInherited(_Child59);

              if (_Child60 !== void 0) {
                if (typeof _Child60 == 'function' && _Child60.name !== 'Child') {
                  Object.defineProperty(_Child60, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child59 = _Child60;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child59;
        }();
        (0, _chai.expect)(new Child().eyeColor()).to.equal("brown");
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return NamedParent;
        }();
        var Child = function () {
          var _NamedChild57 = function (_Parent53) {
            (0, _inherits3.default)(_NamedChild57, _Parent53);

            function _NamedChild57() {
              (0, _classCallCheck3.default)(this, _NamedChild57);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild57).apply(this, arguments));
            }

            return _NamedChild57;
          }(Parent);

          Object.defineProperty(_NamedChild57, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild58 = Parent.onInherited(_NamedChild57);

              if (_NamedChild58 !== void 0) {
                if (typeof _NamedChild58 == 'function' && _NamedChild58.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild58, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild57 = _NamedChild58;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild57;
        }();
        (0, _chai.expect)(new Child().eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp31 = function (_Parents$Parent28) {
              (0, _inherits3.default)(_temp31, _Parents$Parent28);

              function _temp31() {
                (0, _classCallCheck3.default)(this, _temp31);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp31).apply(this, arguments));
              }

              return _temp31;
            }(Parents.Parent);

            Object.defineProperty(_temp31, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp32 = Parents.Parent.onInherited(_temp31);

                if (_temp32 !== void 0) {
                  if (typeof _temp32 == 'function' && _temp32.name !== 'class') {
                    Object.defineProperty(_temp32, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp31 = _temp32;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp31;
          }()
        };
        (0, _chai.expect)(new Children.Child().eyeColor()).to.equal("brown");
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild59 = function (_Parents$Parent29) {
              (0, _inherits3.default)(_NamedChild59, _Parents$Parent29);

              function _NamedChild59() {
                (0, _classCallCheck3.default)(this, _NamedChild59);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild59).apply(this, arguments));
              }

              return _NamedChild59;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild59, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild60 = Parents.Parent.onInherited(_NamedChild59);

                if (_NamedChild60 !== void 0) {
                  if (typeof _NamedChild60 == 'function' && _NamedChild60.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild60, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild59 = _NamedChild60;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild59;
          }()
        };
        (0, _chai.expect)(new Children.Child().eyeColor()).to.equal("brown");
      });
    });
  });
  describe("with a parent that declares a static onInherited method", function () {
    describe("has a reliable name property", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child61 = function (_Parent54) {
            (0, _inherits3.default)(_Child61, _Parent54);

            function _Child61() {
              (0, _classCallCheck3.default)(this, _Child61);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child61).apply(this, arguments));
            }

            return _Child61;
          }(Parent);

          Object.defineProperty(_Child61, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child62 = Parent.onInherited(_Child61);

              if (_Child62 !== void 0) {
                if (typeof _Child62 == 'function' && _Child62.name !== 'Child') {
                  Object.defineProperty(_Child62, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child61 = _Child62;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child61;
        }();

        (0, _chai.expect)(Child.name).to.equal("Child");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();
        var Child = function () {
          var _Child63 = function (_Parent55) {
            (0, _inherits3.default)(_Child63, _Parent55);

            function _Child63() {
              (0, _classCallCheck3.default)(this, _Child63);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child63).apply(this, arguments));
            }

            return _Child63;
          }(Parent);

          Object.defineProperty(_Child63, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child64 = Parent.onInherited(_Child63);

              if (_Child64 !== void 0) {
                if (typeof _Child64 == 'function' && _Child64.name !== 'Child') {
                  Object.defineProperty(_Child64, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child63 = _Child64;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child63;
        }();
        (0, _chai.expect)(Child.name).to.equal("Child");
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedParent;
        }();
        var Child = function () {
          var _NamedChild61 = function (_Parent56) {
            (0, _inherits3.default)(_NamedChild61, _Parent56);

            function _NamedChild61() {
              (0, _classCallCheck3.default)(this, _NamedChild61);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild61).apply(this, arguments));
            }

            return _NamedChild61;
          }(Parent);

          Object.defineProperty(_NamedChild61, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild62 = Parent.onInherited(_NamedChild61);

              if (_NamedChild62 !== void 0) {
                if (typeof _NamedChild62 == 'function' && _NamedChild62.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild62, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild61 = _NamedChild62;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild61;
        }();
        (0, _chai.expect)(Child.name).to.equal("NamedChild");
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild63 = function (_Parents$Parent30) {
              (0, _inherits3.default)(_NamedChild63, _Parents$Parent30);

              function _NamedChild63() {
                (0, _classCallCheck3.default)(this, _NamedChild63);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild63).apply(this, arguments));
              }

              return _NamedChild63;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild63, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild64 = Parents.Parent.onInherited(_NamedChild63);

                if (_NamedChild64 !== void 0) {
                  if (typeof _NamedChild64 == 'function' && _NamedChild64.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild64, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild63 = _NamedChild64;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild63;
          }()
        };
        (0, _chai.expect)(Children.Child.name).to.equal("NamedChild");
      });
    });
    describe("can have static methods", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child65 = function (_Parent57) {
            (0, _inherits3.default)(_Child65, _Parent57);

            function _Child65() {
              (0, _classCallCheck3.default)(this, _Child65);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child65).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child65, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child65;
          }(Parent);

          Object.defineProperty(_Child65, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child66 = Parent.onInherited(_Child65);

              if (_Child66 !== void 0) {
                if (typeof _Child66 == 'function' && _Child66.name !== 'Child') {
                  Object.defineProperty(_Child66, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child65 = _Child66;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child65;
        }();

        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();
        var Child = function () {
          var _Child67 = function (_Parent58) {
            (0, _inherits3.default)(_Child67, _Parent58);

            function _Child67() {
              (0, _classCallCheck3.default)(this, _Child67);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child67).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child67, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child67;
          }(Parent);

          Object.defineProperty(_Child67, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child68 = Parent.onInherited(_Child67);

              if (_Child68 !== void 0) {
                if (typeof _Child68 == 'function' && _Child68.name !== 'Child') {
                  Object.defineProperty(_Child68, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child67 = _Child68;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child67;
        }();
        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedParent;
        }();
        var Child = function () {
          var _NamedChild65 = function (_Parent59) {
            (0, _inherits3.default)(_NamedChild65, _Parent59);

            function _NamedChild65() {
              (0, _classCallCheck3.default)(this, _NamedChild65);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild65).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedChild65, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _NamedChild65;
          }(Parent);

          Object.defineProperty(_NamedChild65, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild66 = Parent.onInherited(_NamedChild65);

              if (_NamedChild66 !== void 0) {
                if (typeof _NamedChild66 == 'function' && _NamedChild66.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild66, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild65 = _NamedChild66;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild65;
        }();
        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp33 = function (_Parents$Parent31) {
              (0, _inherits3.default)(_temp33, _Parents$Parent31);

              function _temp33() {
                (0, _classCallCheck3.default)(this, _temp33);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp33).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp33, null, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _temp33;
            }(Parents.Parent);

            Object.defineProperty(_temp33, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp34 = Parents.Parent.onInherited(_temp33);

                if (_temp34 !== void 0) {
                  if (typeof _temp34 == 'function' && _temp34.name !== 'class') {
                    Object.defineProperty(_temp34, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp33 = _temp34;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp33;
          }()
        };
        (0, _chai.expect)(Children.Child.childishness()).to.equal(6);
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild67 = function (_Parents$Parent32) {
              (0, _inherits3.default)(_NamedChild67, _Parents$Parent32);

              function _NamedChild67() {
                (0, _classCallCheck3.default)(this, _NamedChild67);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild67).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedChild67, null, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _NamedChild67;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild67, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild68 = Parents.Parent.onInherited(_NamedChild67);

                if (_NamedChild68 !== void 0) {
                  if (typeof _NamedChild68 == 'function' && _NamedChild68.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild68, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild67 = _NamedChild68;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild67;
          }()
        };
        (0, _chai.expect)(Children.Child.childishness()).to.equal(6);
      });
    });
    describe("can inherit static methods from its parent", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child69 = function (_Parent60) {
            (0, _inherits3.default)(_Child69, _Parent60);

            function _Child69() {
              (0, _classCallCheck3.default)(this, _Child69);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child69).apply(this, arguments));
            }

            return _Child69;
          }(Parent);

          Object.defineProperty(_Child69, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child70 = Parent.onInherited(_Child69);

              if (_Child70 !== void 0) {
                if (typeof _Child70 == 'function' && _Child70.name !== 'Child') {
                  Object.defineProperty(_Child70, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child69 = _Child70;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child69;
        }();

        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Parent;
        }();
        var Child = function () {
          var _Child71 = function (_Parent61) {
            (0, _inherits3.default)(_Child71, _Parent61);

            function _Child71() {
              (0, _classCallCheck3.default)(this, _Child71);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child71).apply(this, arguments));
            }

            return _Child71;
          }(Parent);

          Object.defineProperty(_Child71, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child72 = Parent.onInherited(_Child71);

              if (_Child72 !== void 0) {
                if (typeof _Child72 == 'function' && _Child72.name !== 'Child') {
                  Object.defineProperty(_Child72, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child71 = _Child72;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child71;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return NamedParent;
        }();
        var Child = function () {
          var _NamedChild69 = function (_Parent62) {
            (0, _inherits3.default)(_NamedChild69, _Parent62);

            function _NamedChild69() {
              (0, _classCallCheck3.default)(this, _NamedChild69);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild69).apply(this, arguments));
            }

            return _NamedChild69;
          }(Parent);

          Object.defineProperty(_NamedChild69, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild70 = Parent.onInherited(_NamedChild69);

              if (_NamedChild70 !== void 0) {
                if (typeof _NamedChild70 == 'function' && _NamedChild70.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild70, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild69 = _NamedChild70;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild69;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }, {
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp35 = function (_Parents$Parent33) {
              (0, _inherits3.default)(_temp35, _Parents$Parent33);

              function _temp35() {
                (0, _classCallCheck3.default)(this, _temp35);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp35).apply(this, arguments));
              }

              return _temp35;
            }(Parents.Parent);

            Object.defineProperty(_temp35, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp36 = Parents.Parent.onInherited(_temp35);

                if (_temp36 !== void 0) {
                  if (typeof _temp36 == 'function' && _temp36.name !== 'class') {
                    Object.defineProperty(_temp36, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp35 = _temp36;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp35;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }, {
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild71 = function (_Parents$Parent34) {
              (0, _inherits3.default)(_NamedChild71, _Parents$Parent34);

              function _NamedChild71() {
                (0, _classCallCheck3.default)(this, _NamedChild71);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild71).apply(this, arguments));
              }

              return _NamedChild71;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild71, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild72 = Parents.Parent.onInherited(_NamedChild71);

                if (_NamedChild72 !== void 0) {
                  if (typeof _NamedChild72 == 'function' && _NamedChild72.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild72, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild71 = _NamedChild72;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild71;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });
    });
    describe("can have instance methods", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child73 = function (_Parent63) {
            (0, _inherits3.default)(_Child73, _Parent63);

            function _Child73() {
              (0, _classCallCheck3.default)(this, _Child73);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child73).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child73, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child73;
          }(Parent);

          Object.defineProperty(_Child73, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child74 = Parent.onInherited(_Child73);

              if (_Child74 !== void 0) {
                if (typeof _Child74 == 'function' && _Child74.name !== 'Child') {
                  Object.defineProperty(_Child74, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child73 = _Child74;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child73;
        }();

        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();
        var Child = function () {
          var _Child75 = function (_Parent64) {
            (0, _inherits3.default)(_Child75, _Parent64);

            function _Child75() {
              (0, _classCallCheck3.default)(this, _Child75);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child75).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child75, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child75;
          }(Parent);

          Object.defineProperty(_Child75, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child76 = Parent.onInherited(_Child75);

              if (_Child76 !== void 0) {
                if (typeof _Child76 == 'function' && _Child76.name !== 'Child') {
                  Object.defineProperty(_Child76, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child75 = _Child76;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child75;
        }();
        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedParent;
        }();
        var Child = function () {
          var _NamedChild73 = function (_Parent65) {
            (0, _inherits3.default)(_NamedChild73, _Parent65);

            function _NamedChild73() {
              (0, _classCallCheck3.default)(this, _NamedChild73);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild73).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedChild73, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _NamedChild73;
          }(Parent);

          Object.defineProperty(_NamedChild73, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild74 = Parent.onInherited(_NamedChild73);

              if (_NamedChild74 !== void 0) {
                if (typeof _NamedChild74 == 'function' && _NamedChild74.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild74, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild73 = _NamedChild74;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild73;
        }();
        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp37 = function (_Parents$Parent35) {
              (0, _inherits3.default)(_temp37, _Parents$Parent35);

              function _temp37() {
                (0, _classCallCheck3.default)(this, _temp37);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp37).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp37, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _temp37;
            }(Parents.Parent);

            Object.defineProperty(_temp37, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp38 = Parents.Parent.onInherited(_temp37);

                if (_temp38 !== void 0) {
                  if (typeof _temp38 == 'function' && _temp38.name !== 'class') {
                    Object.defineProperty(_temp38, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp37 = _temp38;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp37;
          }()
        };
        (0, _chai.expect)(new Children.Child().childishness()).to.equal(6);
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild75 = function (_Parents$Parent36) {
              (0, _inherits3.default)(_NamedChild75, _Parents$Parent36);

              function _NamedChild75() {
                (0, _classCallCheck3.default)(this, _NamedChild75);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild75).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedChild75, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _NamedChild75;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild75, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild76 = Parents.Parent.onInherited(_NamedChild75);

                if (_NamedChild76 !== void 0) {
                  if (typeof _NamedChild76 == 'function' && _NamedChild76.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild76, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild75 = _NamedChild76;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild75;
          }()
        };
        (0, _chai.expect)(new Children.Child().childishness()).to.equal(6);
      });
    });
    describe("can inherit instance methods from its parent", function () {
      it("using named class declarations", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();

        var Child = function () {
          var _Child77 = function (_Parent66) {
            (0, _inherits3.default)(_Child77, _Parent66);

            function _Child77() {
              (0, _classCallCheck3.default)(this, _Child77);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child77).apply(this, arguments));
            }

            return _Child77;
          }(Parent);

          Object.defineProperty(_Child77, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child78 = Parent.onInherited(_Child77);

              if (_Child78 !== void 0) {
                if (typeof _Child78 == 'function' && _Child78.name !== 'Child') {
                  Object.defineProperty(_Child78, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child77 = _Child78;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child77;
        }();

        (0, _chai.expect)(new Child().eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Parent = function () {
          function Parent() {
            (0, _classCallCheck3.default)(this, Parent);
          }

          (0, _createClass3.default)(Parent, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Parent;
        }();
        var Child = function () {
          var _Child79 = function (_Parent67) {
            (0, _inherits3.default)(_Child79, _Parent67);

            function _Child79() {
              (0, _classCallCheck3.default)(this, _Child79);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child79).apply(this, arguments));
            }

            return _Child79;
          }(Parent);

          Object.defineProperty(_Child79, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child80 = Parent.onInherited(_Child79);

              if (_Child80 !== void 0) {
                if (typeof _Child80 == 'function' && _Child80.name !== 'Child') {
                  Object.defineProperty(_Child80, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child79 = _Child80;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child79;
        }();
        (0, _chai.expect)(new Child().eyeColor()).to.equal("brown");
      });

      it("using named class expressions saved as variables", function () {
        var Parent = function () {
          function NamedParent() {
            (0, _classCallCheck3.default)(this, NamedParent);
          }

          (0, _createClass3.default)(NamedParent, [{
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedParent;
        }();
        var Child = function () {
          var _NamedChild77 = function (_Parent68) {
            (0, _inherits3.default)(_NamedChild77, _Parent68);

            function _NamedChild77() {
              (0, _classCallCheck3.default)(this, _NamedChild77);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild77).apply(this, arguments));
            }

            return _NamedChild77;
          }(Parent);

          Object.defineProperty(_NamedChild77, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild78 = Parent.onInherited(_NamedChild77);

              if (_NamedChild78 !== void 0) {
                if (typeof _NamedChild78 == 'function' && _NamedChild78.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild78, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild77 = _NamedChild78;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild77;
        }();
        (0, _chai.expect)(new Child().eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function Parent() {
              (0, _classCallCheck3.default)(this, Parent);
            }

            (0, _createClass3.default)(Parent, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }], [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Parent;
          }()
        };

        var Children = {
          Child: function () {
            var _temp39 = function (_Parents$Parent37) {
              (0, _inherits3.default)(_temp39, _Parents$Parent37);

              function _temp39() {
                (0, _classCallCheck3.default)(this, _temp39);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp39).apply(this, arguments));
              }

              return _temp39;
            }(Parents.Parent);

            Object.defineProperty(_temp39, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp40 = Parents.Parent.onInherited(_temp39);

                if (_temp40 !== void 0) {
                  if (typeof _temp40 == 'function' && _temp40.name !== 'class') {
                    Object.defineProperty(_temp40, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp39 = _temp40;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp39;
          }()
        };
        (0, _chai.expect)(new Children.Child().eyeColor()).to.equal("brown");
      });

      it("using named class expressions on object literal properties", function () {
        var Parents = {
          Parent: function () {
            function NamedParent() {
              (0, _classCallCheck3.default)(this, NamedParent);
            }

            (0, _createClass3.default)(NamedParent, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }], [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedParent;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild79 = function (_Parents$Parent38) {
              (0, _inherits3.default)(_NamedChild79, _Parents$Parent38);

              function _NamedChild79() {
                (0, _classCallCheck3.default)(this, _NamedChild79);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild79).apply(this, arguments));
              }

              return _NamedChild79;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild79, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild80 = Parents.Parent.onInherited(_NamedChild79);

                if (_NamedChild80 !== void 0) {
                  if (typeof _NamedChild80 == 'function' && _NamedChild80.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild80, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild79 = _NamedChild80;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild79;
          }()
        };
        (0, _chai.expect)(new Children.Child().eyeColor()).to.equal("brown");
      });
    });
  });
  describe("with a grandparent that declares a static onInherited method", function () {
    describe("has a reliable name property", function () {
      it("using named class declarations", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent69 = function (_Grandparent7) {
            (0, _inherits3.default)(_Parent69, _Grandparent7);

            function _Parent69() {
              (0, _classCallCheck3.default)(this, _Parent69);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent69).apply(this, arguments));
            }

            return _Parent69;
          }(Grandparent);

          Object.defineProperty(_Parent69, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent70 = Grandparent.onInherited(_Parent69);

              if (_Parent70 !== void 0) {
                if (typeof _Parent70 == 'function' && _Parent70.name !== 'Parent') {
                  Object.defineProperty(_Parent70, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent69 = _Parent70;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent69;
        }();

        var Child = function () {
          var _Child81 = function (_Parent71) {
            (0, _inherits3.default)(_Child81, _Parent71);

            function _Child81() {
              (0, _classCallCheck3.default)(this, _Child81);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child81).apply(this, arguments));
            }

            return _Child81;
          }(Parent);

          Object.defineProperty(_Child81, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child82 = Parent.onInherited(_Child81);

              if (_Child82 !== void 0) {
                if (typeof _Child82 == 'function' && _Child82.name !== 'Child') {
                  Object.defineProperty(_Child82, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child81 = _Child82;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child81;
        }();

        (0, _chai.expect)(Child.name).to.equal("Child");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();
        var Parent = function () {
          var _Parent72 = function (_Grandparent8) {
            (0, _inherits3.default)(_Parent72, _Grandparent8);

            function _Parent72() {
              (0, _classCallCheck3.default)(this, _Parent72);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent72).apply(this, arguments));
            }

            return _Parent72;
          }(Grandparent);

          Object.defineProperty(_Parent72, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent73 = Grandparent.onInherited(_Parent72);

              if (_Parent73 !== void 0) {
                if (typeof _Parent73 == 'function' && _Parent73.name !== 'Parent') {
                  Object.defineProperty(_Parent73, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent72 = _Parent73;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent72;
        }();
        var Child = function () {
          var _Child83 = function (_Parent74) {
            (0, _inherits3.default)(_Child83, _Parent74);

            function _Child83() {
              (0, _classCallCheck3.default)(this, _Child83);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child83).apply(this, arguments));
            }

            return _Child83;
          }(Parent);

          Object.defineProperty(_Child83, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child84 = Parent.onInherited(_Child83);

              if (_Child84 !== void 0) {
                if (typeof _Child84 == 'function' && _Child84.name !== 'Child') {
                  Object.defineProperty(_Child84, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child83 = _Child84;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child83;
        }();
        (0, _chai.expect)(Child.name).to.equal("Child");
      });

      it("using named class expressions saved as variables", function () {
        var Grandparent = function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedGrandparent;
        }();
        var Parent = function () {
          var _NamedParent9 = function (_Grandparent9) {
            (0, _inherits3.default)(_NamedParent9, _Grandparent9);

            function _NamedParent9() {
              (0, _classCallCheck3.default)(this, _NamedParent9);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent9).apply(this, arguments));
            }

            return _NamedParent9;
          }(Grandparent);

          Object.defineProperty(_NamedParent9, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _NamedParent10 = Grandparent.onInherited(_NamedParent9);

              if (_NamedParent10 !== void 0) {
                if (typeof _NamedParent10 == 'function' && _NamedParent10.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent10, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent9 = _NamedParent10;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent9;
        }();
        var Child = function () {
          var _NamedChild81 = function (_Parent75) {
            (0, _inherits3.default)(_NamedChild81, _Parent75);

            function _NamedChild81() {
              (0, _classCallCheck3.default)(this, _NamedChild81);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild81).apply(this, arguments));
            }

            return _NamedChild81;
          }(Parent);

          Object.defineProperty(_NamedChild81, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild82 = Parent.onInherited(_NamedChild81);

              if (_NamedChild82 !== void 0) {
                if (typeof _NamedChild82 == 'function' && _NamedChild82.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild82, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild81 = _NamedChild82;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild81;
        }();
        (0, _chai.expect)(Child.name).to.equal("NamedChild");
      });

      it("using named class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function NamedGrandparent() {
              (0, _classCallCheck3.default)(this, NamedGrandparent);
            }

            (0, _createClass3.default)(NamedGrandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedGrandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _NamedParent11 = function (_Grandparents$Grandpa5) {
              (0, _inherits3.default)(_NamedParent11, _Grandparents$Grandpa5);

              function _NamedParent11() {
                (0, _classCallCheck3.default)(this, _NamedParent11);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent11).apply(this, arguments));
              }

              return _NamedParent11;
            }(Grandparents.Grandparent);

            Object.defineProperty(_NamedParent11, "name", {
              value: 'NamedParent',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _NamedParent12 = Grandparents.Grandparent.onInherited(_NamedParent11);

                if (_NamedParent12 !== void 0) {
                  if (typeof _NamedParent12 == 'function' && _NamedParent12.name !== 'NamedParent') {
                    Object.defineProperty(_NamedParent12, "name", {
                      value: 'NamedParent',
                      configurable: true
                    });
                  }

                  _NamedParent11 = _NamedParent12;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedParent11;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild83 = function (_Parents$Parent39) {
              (0, _inherits3.default)(_NamedChild83, _Parents$Parent39);

              function _NamedChild83() {
                (0, _classCallCheck3.default)(this, _NamedChild83);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild83).apply(this, arguments));
              }

              return _NamedChild83;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild83, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild84 = Parents.Parent.onInherited(_NamedChild83);

                if (_NamedChild84 !== void 0) {
                  if (typeof _NamedChild84 == 'function' && _NamedChild84.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild84, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild83 = _NamedChild84;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild83;
          }()
        };
        (0, _chai.expect)(Children.Child.name).to.equal("NamedChild");
      });
    });
    describe("can have static methods", function () {
      it("using named class declarations", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent76 = function (_Grandparent10) {
            (0, _inherits3.default)(_Parent76, _Grandparent10);

            function _Parent76() {
              (0, _classCallCheck3.default)(this, _Parent76);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent76).apply(this, arguments));
            }

            return _Parent76;
          }(Grandparent);

          Object.defineProperty(_Parent76, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent77 = Grandparent.onInherited(_Parent76);

              if (_Parent77 !== void 0) {
                if (typeof _Parent77 == 'function' && _Parent77.name !== 'Parent') {
                  Object.defineProperty(_Parent77, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent76 = _Parent77;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent76;
        }();

        var Child = function () {
          var _Child85 = function (_Parent78) {
            (0, _inherits3.default)(_Child85, _Parent78);

            function _Child85() {
              (0, _classCallCheck3.default)(this, _Child85);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child85).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child85, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child85;
          }(Parent);

          Object.defineProperty(_Child85, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child86 = Parent.onInherited(_Child85);

              if (_Child86 !== void 0) {
                if (typeof _Child86 == 'function' && _Child86.name !== 'Child') {
                  Object.defineProperty(_Child86, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child85 = _Child86;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child85;
        }();

        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();
        var Parent = function () {
          var _Parent79 = function (_Grandparent11) {
            (0, _inherits3.default)(_Parent79, _Grandparent11);

            function _Parent79() {
              (0, _classCallCheck3.default)(this, _Parent79);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent79).apply(this, arguments));
            }

            return _Parent79;
          }(Grandparent);

          Object.defineProperty(_Parent79, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent80 = Grandparent.onInherited(_Parent79);

              if (_Parent80 !== void 0) {
                if (typeof _Parent80 == 'function' && _Parent80.name !== 'Parent') {
                  Object.defineProperty(_Parent80, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent79 = _Parent80;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent79;
        }();
        var Child = function () {
          var _Child87 = function (_Parent81) {
            (0, _inherits3.default)(_Child87, _Parent81);

            function _Child87() {
              (0, _classCallCheck3.default)(this, _Child87);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child87).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child87, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child87;
          }(Parent);

          Object.defineProperty(_Child87, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child88 = Parent.onInherited(_Child87);

              if (_Child88 !== void 0) {
                if (typeof _Child88 == 'function' && _Child88.name !== 'Child') {
                  Object.defineProperty(_Child88, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child87 = _Child88;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child87;
        }();
        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using named class expressions saved as variables", function () {
        var Grandparent = function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedGrandparent;
        }();
        var Parent = function () {
          var _NamedParent13 = function (_Grandparent12) {
            (0, _inherits3.default)(_NamedParent13, _Grandparent12);

            function _NamedParent13() {
              (0, _classCallCheck3.default)(this, _NamedParent13);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent13).apply(this, arguments));
            }

            return _NamedParent13;
          }(Grandparent);

          Object.defineProperty(_NamedParent13, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _NamedParent14 = Grandparent.onInherited(_NamedParent13);

              if (_NamedParent14 !== void 0) {
                if (typeof _NamedParent14 == 'function' && _NamedParent14.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent14, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent13 = _NamedParent14;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent13;
        }();
        var Child = function () {
          var _NamedChild85 = function (_Parent82) {
            (0, _inherits3.default)(_NamedChild85, _Parent82);

            function _NamedChild85() {
              (0, _classCallCheck3.default)(this, _NamedChild85);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild85).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedChild85, null, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _NamedChild85;
          }(Parent);

          Object.defineProperty(_NamedChild85, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild86 = Parent.onInherited(_NamedChild85);

              if (_NamedChild86 !== void 0) {
                if (typeof _NamedChild86 == 'function' && _NamedChild86.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild86, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild85 = _NamedChild86;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild85;
        }();
        (0, _chai.expect)(Child.childishness()).to.equal(6);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function Grandparent() {
              (0, _classCallCheck3.default)(this, Grandparent);
            }

            (0, _createClass3.default)(Grandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Grandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _temp41 = function (_Grandparents$Grandpa6) {
              (0, _inherits3.default)(_temp41, _Grandparents$Grandpa6);

              function _temp41() {
                (0, _classCallCheck3.default)(this, _temp41);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp41).apply(this, arguments));
              }

              return _temp41;
            }(Grandparents.Grandparent);

            Object.defineProperty(_temp41, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _temp42 = Grandparents.Grandparent.onInherited(_temp41);

                if (_temp42 !== void 0) {
                  if (typeof _temp42 == 'function' && _temp42.name !== 'class') {
                    Object.defineProperty(_temp42, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp41 = _temp42;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp41;
          }()
        };

        var Children = {
          Child: function () {
            var _temp43 = function (_Parents$Parent40) {
              (0, _inherits3.default)(_temp43, _Parents$Parent40);

              function _temp43() {
                (0, _classCallCheck3.default)(this, _temp43);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp43).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp43, null, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _temp43;
            }(Parents.Parent);

            Object.defineProperty(_temp43, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp44 = Parents.Parent.onInherited(_temp43);

                if (_temp44 !== void 0) {
                  if (typeof _temp44 == 'function' && _temp44.name !== 'class') {
                    Object.defineProperty(_temp44, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp43 = _temp44;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp43;
          }()
        };
        (0, _chai.expect)(Children.Child.childishness()).to.equal(6);
      });

      it("using named class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function NamedGrandparent() {
              (0, _classCallCheck3.default)(this, NamedGrandparent);
            }

            (0, _createClass3.default)(NamedGrandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedGrandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _NamedParent15 = function (_Grandparents$Grandpa7) {
              (0, _inherits3.default)(_NamedParent15, _Grandparents$Grandpa7);

              function _NamedParent15() {
                (0, _classCallCheck3.default)(this, _NamedParent15);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent15).apply(this, arguments));
              }

              return _NamedParent15;
            }(Grandparents.Grandparent);

            Object.defineProperty(_NamedParent15, "name", {
              value: 'NamedParent',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _NamedParent16 = Grandparents.Grandparent.onInherited(_NamedParent15);

                if (_NamedParent16 !== void 0) {
                  if (typeof _NamedParent16 == 'function' && _NamedParent16.name !== 'NamedParent') {
                    Object.defineProperty(_NamedParent16, "name", {
                      value: 'NamedParent',
                      configurable: true
                    });
                  }

                  _NamedParent15 = _NamedParent16;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedParent15;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild87 = function (_Parents$Parent41) {
              (0, _inherits3.default)(_NamedChild87, _Parents$Parent41);

              function _NamedChild87() {
                (0, _classCallCheck3.default)(this, _NamedChild87);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild87).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedChild87, null, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _NamedChild87;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild87, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild88 = Parents.Parent.onInherited(_NamedChild87);

                if (_NamedChild88 !== void 0) {
                  if (typeof _NamedChild88 == 'function' && _NamedChild88.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild88, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild87 = _NamedChild88;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild87;
          }()
        };
        (0, _chai.expect)(Children.Child.childishness()).to.equal(6);
      });
    });
    describe("can inherit static methods from its parent", function () {
      it("using named class declarations", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent83 = function (_Grandparent13) {
            (0, _inherits3.default)(_Parent83, _Grandparent13);

            function _Parent83() {
              (0, _classCallCheck3.default)(this, _Parent83);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent83).apply(this, arguments));
            }

            (0, _createClass3.default)(_Parent83, null, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return _Parent83;
          }(Grandparent);

          Object.defineProperty(_Parent83, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent84 = Grandparent.onInherited(_Parent83);

              if (_Parent84 !== void 0) {
                if (typeof _Parent84 == 'function' && _Parent84.name !== 'Parent') {
                  Object.defineProperty(_Parent84, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent83 = _Parent84;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent83;
        }();

        var Child = function () {
          var _Child89 = function (_Parent85) {
            (0, _inherits3.default)(_Child89, _Parent85);

            function _Child89() {
              (0, _classCallCheck3.default)(this, _Child89);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child89).apply(this, arguments));
            }

            return _Child89;
          }(Parent);

          Object.defineProperty(_Child89, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child90 = Parent.onInherited(_Child89);

              if (_Child90 !== void 0) {
                if (typeof _Child90 == 'function' && _Child90.name !== 'Child') {
                  Object.defineProperty(_Child90, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child89 = _Child90;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child89;
        }();

        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent86 = function (_Grandparent14) {
            (0, _inherits3.default)(_Parent86, _Grandparent14);

            function _Parent86() {
              (0, _classCallCheck3.default)(this, _Parent86);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent86).apply(this, arguments));
            }

            (0, _createClass3.default)(_Parent86, null, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return _Parent86;
          }(Grandparent);

          Object.defineProperty(_Parent86, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent87 = Grandparent.onInherited(_Parent86);

              if (_Parent87 !== void 0) {
                if (typeof _Parent87 == 'function' && _Parent87.name !== 'Parent') {
                  Object.defineProperty(_Parent87, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent86 = _Parent87;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent86;
        }();
        var Child = function () {
          var _Child91 = function (_Parent88) {
            (0, _inherits3.default)(_Child91, _Parent88);

            function _Child91() {
              (0, _classCallCheck3.default)(this, _Child91);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child91).apply(this, arguments));
            }

            return _Child91;
          }(Parent);

          Object.defineProperty(_Child91, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child92 = Parent.onInherited(_Child91);

              if (_Child92 !== void 0) {
                if (typeof _Child92 == 'function' && _Child92.name !== 'Child') {
                  Object.defineProperty(_Child92, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child91 = _Child92;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child91;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions saved as variables", function () {
        var Grandparent = function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedGrandparent;
        }();

        var Parent = function () {
          var _NamedParent17 = function (_Grandparent15) {
            (0, _inherits3.default)(_NamedParent17, _Grandparent15);

            function _NamedParent17() {
              (0, _classCallCheck3.default)(this, _NamedParent17);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent17).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedParent17, null, [{
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return _NamedParent17;
          }(Grandparent);

          Object.defineProperty(_NamedParent17, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _NamedParent18 = Grandparent.onInherited(_NamedParent17);

              if (_NamedParent18 !== void 0) {
                if (typeof _NamedParent18 == 'function' && _NamedParent18.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent18, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent17 = _NamedParent18;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent17;
        }();
        var Child = function () {
          var _NamedChild89 = function (_Parent89) {
            (0, _inherits3.default)(_NamedChild89, _Parent89);

            function _NamedChild89() {
              (0, _classCallCheck3.default)(this, _NamedChild89);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild89).apply(this, arguments));
            }

            return _NamedChild89;
          }(Parent);

          Object.defineProperty(_NamedChild89, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild90 = Parent.onInherited(_NamedChild89);

              if (_NamedChild90 !== void 0) {
                if (typeof _NamedChild90 == 'function' && _NamedChild90.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild90, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild89 = _NamedChild90;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild89;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function Grandparent() {
              (0, _classCallCheck3.default)(this, Grandparent);
            }

            (0, _createClass3.default)(Grandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Grandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _temp45 = function (_Grandparents$Grandpa8) {
              (0, _inherits3.default)(_temp45, _Grandparents$Grandpa8);

              function _temp45() {
                (0, _classCallCheck3.default)(this, _temp45);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp45).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp45, null, [{
                key: 'eyeColor',
                value: function eyeColor() {
                  return "brown";
                }
              }]);
              return _temp45;
            }(Grandparents.Grandparent);

            Object.defineProperty(_temp45, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _temp46 = Grandparents.Grandparent.onInherited(_temp45);

                if (_temp46 !== void 0) {
                  if (typeof _temp46 == 'function' && _temp46.name !== 'class') {
                    Object.defineProperty(_temp46, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp45 = _temp46;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp45;
          }()
        };

        var Children = {
          Child: function () {
            var _temp47 = function (_Parents$Parent42) {
              (0, _inherits3.default)(_temp47, _Parents$Parent42);

              function _temp47() {
                (0, _classCallCheck3.default)(this, _temp47);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp47).apply(this, arguments));
              }

              return _temp47;
            }(Parents.Parent);

            Object.defineProperty(_temp47, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp48 = Parents.Parent.onInherited(_temp47);

                if (_temp48 !== void 0) {
                  if (typeof _temp48 == 'function' && _temp48.name !== 'class') {
                    Object.defineProperty(_temp48, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp47 = _temp48;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp47;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function NamedGrandparent() {
              (0, _classCallCheck3.default)(this, NamedGrandparent);
            }

            (0, _createClass3.default)(NamedGrandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedGrandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _NamedParent19 = function (_Grandparents$Grandpa9) {
              (0, _inherits3.default)(_NamedParent19, _Grandparents$Grandpa9);

              function _NamedParent19() {
                (0, _classCallCheck3.default)(this, _NamedParent19);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent19).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedParent19, null, [{
                key: 'eyeColor',
                value: function eyeColor() {
                  return "brown";
                }
              }]);
              return _NamedParent19;
            }(Grandparents.Grandparent);

            Object.defineProperty(_NamedParent19, "name", {
              value: 'NamedParent',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _NamedParent20 = Grandparents.Grandparent.onInherited(_NamedParent19);

                if (_NamedParent20 !== void 0) {
                  if (typeof _NamedParent20 == 'function' && _NamedParent20.name !== 'NamedParent') {
                    Object.defineProperty(_NamedParent20, "name", {
                      value: 'NamedParent',
                      configurable: true
                    });
                  }

                  _NamedParent19 = _NamedParent20;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedParent19;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild91 = function (_Parents$Parent43) {
              (0, _inherits3.default)(_NamedChild91, _Parents$Parent43);

              function _NamedChild91() {
                (0, _classCallCheck3.default)(this, _NamedChild91);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild91).apply(this, arguments));
              }

              return _NamedChild91;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild91, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild92 = Parents.Parent.onInherited(_NamedChild91);

                if (_NamedChild92 !== void 0) {
                  if (typeof _NamedChild92 == 'function' && _NamedChild92.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild92, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild91 = _NamedChild92;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild91;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });
    });
    describe("can inherit static methods from its grandparent", function () {
      it("using named class declarations", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent90 = function (_Grandparent16) {
            (0, _inherits3.default)(_Parent90, _Grandparent16);

            function _Parent90() {
              (0, _classCallCheck3.default)(this, _Parent90);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent90).apply(this, arguments));
            }

            return _Parent90;
          }(Grandparent);

          Object.defineProperty(_Parent90, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent91 = Grandparent.onInherited(_Parent90);

              if (_Parent91 !== void 0) {
                if (typeof _Parent91 == 'function' && _Parent91.name !== 'Parent') {
                  Object.defineProperty(_Parent91, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent90 = _Parent91;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent90;
        }();

        var Child = function () {
          var _Child93 = function (_Parent92) {
            (0, _inherits3.default)(_Child93, _Parent92);

            function _Child93() {
              (0, _classCallCheck3.default)(this, _Child93);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child93).apply(this, arguments));
            }

            return _Child93;
          }(Parent);

          Object.defineProperty(_Child93, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child94 = Parent.onInherited(_Child93);

              if (_Child94 !== void 0) {
                if (typeof _Child94 == 'function' && _Child94.name !== 'Child') {
                  Object.defineProperty(_Child94, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child93 = _Child94;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child93;
        }();

        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent93 = function (_Grandparent17) {
            (0, _inherits3.default)(_Parent93, _Grandparent17);

            function _Parent93() {
              (0, _classCallCheck3.default)(this, _Parent93);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent93).apply(this, arguments));
            }

            return _Parent93;
          }(Grandparent);

          Object.defineProperty(_Parent93, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent94 = Grandparent.onInherited(_Parent93);

              if (_Parent94 !== void 0) {
                if (typeof _Parent94 == 'function' && _Parent94.name !== 'Parent') {
                  Object.defineProperty(_Parent94, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent93 = _Parent94;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent93;
        }();
        var Child = function () {
          var _Child95 = function (_Parent95) {
            (0, _inherits3.default)(_Child95, _Parent95);

            function _Child95() {
              (0, _classCallCheck3.default)(this, _Child95);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child95).apply(this, arguments));
            }

            return _Child95;
          }(Parent);

          Object.defineProperty(_Child95, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child96 = Parent.onInherited(_Child95);

              if (_Child96 !== void 0) {
                if (typeof _Child96 == 'function' && _Child96.name !== 'Child') {
                  Object.defineProperty(_Child96, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child95 = _Child96;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child95;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions saved as variables", function () {
        var Grandparent = function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }, {
            key: 'eyeColor',
            value: function eyeColor() {
              return "brown";
            }
          }]);
          return NamedGrandparent;
        }();

        var Parent = function () {
          var _NamedParent21 = function (_Grandparent18) {
            (0, _inherits3.default)(_NamedParent21, _Grandparent18);

            function _NamedParent21() {
              (0, _classCallCheck3.default)(this, _NamedParent21);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent21).apply(this, arguments));
            }

            return _NamedParent21;
          }(Grandparent);

          Object.defineProperty(_NamedParent21, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _NamedParent22 = Grandparent.onInherited(_NamedParent21);

              if (_NamedParent22 !== void 0) {
                if (typeof _NamedParent22 == 'function' && _NamedParent22.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent22, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent21 = _NamedParent22;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent21;
        }();
        var Child = function () {
          var _NamedChild93 = function (_Parent96) {
            (0, _inherits3.default)(_NamedChild93, _Parent96);

            function _NamedChild93() {
              (0, _classCallCheck3.default)(this, _NamedChild93);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild93).apply(this, arguments));
            }

            return _NamedChild93;
          }(Parent);

          Object.defineProperty(_NamedChild93, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild94 = Parent.onInherited(_NamedChild93);

              if (_NamedChild94 !== void 0) {
                if (typeof _NamedChild94 == 'function' && _NamedChild94.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild94, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild93 = _NamedChild94;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild93;
        }();
        (0, _chai.expect)(Child.eyeColor()).to.equal("brown");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function Grandparent() {
              (0, _classCallCheck3.default)(this, Grandparent);
            }

            (0, _createClass3.default)(Grandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }, {
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return Grandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _temp49 = function (_Grandparents$Grandpa10) {
              (0, _inherits3.default)(_temp49, _Grandparents$Grandpa10);

              function _temp49() {
                (0, _classCallCheck3.default)(this, _temp49);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp49).apply(this, arguments));
              }

              return _temp49;
            }(Grandparents.Grandparent);

            Object.defineProperty(_temp49, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _temp50 = Grandparents.Grandparent.onInherited(_temp49);

                if (_temp50 !== void 0) {
                  if (typeof _temp50 == 'function' && _temp50.name !== 'class') {
                    Object.defineProperty(_temp50, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp49 = _temp50;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp49;
          }()
        };

        var Children = {
          Child: function () {
            var _temp51 = function (_Parents$Parent44) {
              (0, _inherits3.default)(_temp51, _Parents$Parent44);

              function _temp51() {
                (0, _classCallCheck3.default)(this, _temp51);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp51).apply(this, arguments));
              }

              return _temp51;
            }(Parents.Parent);

            Object.defineProperty(_temp51, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp52 = Parents.Parent.onInherited(_temp51);

                if (_temp52 !== void 0) {
                  if (typeof _temp52 == 'function' && _temp52.name !== 'class') {
                    Object.defineProperty(_temp52, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp51 = _temp52;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp51;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });

      it("using named class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function NamedGrandparent() {
              (0, _classCallCheck3.default)(this, NamedGrandparent);
            }

            (0, _createClass3.default)(NamedGrandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }, {
              key: 'eyeColor',
              value: function eyeColor() {
                return "brown";
              }
            }]);
            return NamedGrandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _NamedParent23 = function (_Grandparents$Grandpa11) {
              (0, _inherits3.default)(_NamedParent23, _Grandparents$Grandpa11);

              function _NamedParent23() {
                (0, _classCallCheck3.default)(this, _NamedParent23);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent23).apply(this, arguments));
              }

              return _NamedParent23;
            }(Grandparents.Grandparent);

            Object.defineProperty(_NamedParent23, "name", {
              value: 'NamedParent',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _NamedParent24 = Grandparents.Grandparent.onInherited(_NamedParent23);

                if (_NamedParent24 !== void 0) {
                  if (typeof _NamedParent24 == 'function' && _NamedParent24.name !== 'NamedParent') {
                    Object.defineProperty(_NamedParent24, "name", {
                      value: 'NamedParent',
                      configurable: true
                    });
                  }

                  _NamedParent23 = _NamedParent24;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedParent23;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild95 = function (_Parents$Parent45) {
              (0, _inherits3.default)(_NamedChild95, _Parents$Parent45);

              function _NamedChild95() {
                (0, _classCallCheck3.default)(this, _NamedChild95);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild95).apply(this, arguments));
              }

              return _NamedChild95;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild95, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild96 = Parents.Parent.onInherited(_NamedChild95);

                if (_NamedChild96 !== void 0) {
                  if (typeof _NamedChild96 == 'function' && _NamedChild96.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild96, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild95 = _NamedChild96;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild95;
          }()
        };
        (0, _chai.expect)(Children.Child.eyeColor()).to.equal("brown");
      });
    });
    describe("can have instance methods", function () {
      it("using named class declarations", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent97 = function (_Grandparent19) {
            (0, _inherits3.default)(_Parent97, _Grandparent19);

            function _Parent97() {
              (0, _classCallCheck3.default)(this, _Parent97);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent97).apply(this, arguments));
            }

            return _Parent97;
          }(Grandparent);

          Object.defineProperty(_Parent97, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent98 = Grandparent.onInherited(_Parent97);

              if (_Parent98 !== void 0) {
                if (typeof _Parent98 == 'function' && _Parent98.name !== 'Parent') {
                  Object.defineProperty(_Parent98, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent97 = _Parent98;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent97;
        }();

        var Child = function () {
          var _Child97 = function (_Parent99) {
            (0, _inherits3.default)(_Child97, _Parent99);

            function _Child97() {
              (0, _classCallCheck3.default)(this, _Child97);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child97).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child97, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child97;
          }(Parent);

          Object.defineProperty(_Child97, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child98 = Parent.onInherited(_Child97);

              if (_Child98 !== void 0) {
                if (typeof _Child98 == 'function' && _Child98.name !== 'Child') {
                  Object.defineProperty(_Child98, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child97 = _Child98;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child97;
        }();

        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent100 = function (_Grandparent20) {
            (0, _inherits3.default)(_Parent100, _Grandparent20);

            function _Parent100() {
              (0, _classCallCheck3.default)(this, _Parent100);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent100).apply(this, arguments));
            }

            return _Parent100;
          }(Grandparent);

          Object.defineProperty(_Parent100, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent101 = Grandparent.onInherited(_Parent100);

              if (_Parent101 !== void 0) {
                if (typeof _Parent101 == 'function' && _Parent101.name !== 'Parent') {
                  Object.defineProperty(_Parent101, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent100 = _Parent101;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent100;
        }();
        var Child = function () {
          var _Child99 = function (_Parent102) {
            (0, _inherits3.default)(_Child99, _Parent102);

            function _Child99() {
              (0, _classCallCheck3.default)(this, _Child99);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child99).apply(this, arguments));
            }

            (0, _createClass3.default)(_Child99, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _Child99;
          }(Parent);

          Object.defineProperty(_Child99, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child100 = Parent.onInherited(_Child99);

              if (_Child100 !== void 0) {
                if (typeof _Child100 == 'function' && _Child100.name !== 'Child') {
                  Object.defineProperty(_Child100, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child99 = _Child100;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child99;
        }();
        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using named class expressions saved as variables", function () {
        var Grandparent = function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedGrandparent;
        }();

        var Parent = function () {
          var _NamedParent25 = function (_Grandparent21) {
            (0, _inherits3.default)(_NamedParent25, _Grandparent21);

            function _NamedParent25() {
              (0, _classCallCheck3.default)(this, _NamedParent25);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent25).apply(this, arguments));
            }

            return _NamedParent25;
          }(Grandparent);

          Object.defineProperty(_NamedParent25, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _NamedParent26 = Grandparent.onInherited(_NamedParent25);

              if (_NamedParent26 !== void 0) {
                if (typeof _NamedParent26 == 'function' && _NamedParent26.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent26, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent25 = _NamedParent26;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent25;
        }();
        var Child = function () {
          var _NamedChild97 = function (_Parent103) {
            (0, _inherits3.default)(_NamedChild97, _Parent103);

            function _NamedChild97() {
              (0, _classCallCheck3.default)(this, _NamedChild97);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild97).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedChild97, [{
              key: 'childishness',
              value: function childishness() {
                return 6;
              }
            }]);
            return _NamedChild97;
          }(Parent);

          Object.defineProperty(_NamedChild97, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild98 = Parent.onInherited(_NamedChild97);

              if (_NamedChild98 !== void 0) {
                if (typeof _NamedChild98 == 'function' && _NamedChild98.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild98, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild97 = _NamedChild98;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild97;
        }();
        (0, _chai.expect)(new Child().childishness()).to.equal(6);
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function Grandparent() {
              (0, _classCallCheck3.default)(this, Grandparent);
            }

            (0, _createClass3.default)(Grandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Grandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _temp53 = function (_Grandparents$Grandpa12) {
              (0, _inherits3.default)(_temp53, _Grandparents$Grandpa12);

              function _temp53() {
                (0, _classCallCheck3.default)(this, _temp53);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp53).apply(this, arguments));
              }

              return _temp53;
            }(Grandparents.Grandparent);

            Object.defineProperty(_temp53, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _temp54 = Grandparents.Grandparent.onInherited(_temp53);

                if (_temp54 !== void 0) {
                  if (typeof _temp54 == 'function' && _temp54.name !== 'class') {
                    Object.defineProperty(_temp54, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp53 = _temp54;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp53;
          }()
        };

        var Children = {
          Child: function () {
            var _temp55 = function (_Parents$Parent46) {
              (0, _inherits3.default)(_temp55, _Parents$Parent46);

              function _temp55() {
                (0, _classCallCheck3.default)(this, _temp55);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp55).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp55, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _temp55;
            }(Parents.Parent);

            Object.defineProperty(_temp55, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp56 = Parents.Parent.onInherited(_temp55);

                if (_temp56 !== void 0) {
                  if (typeof _temp56 == 'function' && _temp56.name !== 'class') {
                    Object.defineProperty(_temp56, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp55 = _temp56;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp55;
          }()
        };
        (0, _chai.expect)(new Children.Child().childishness()).to.equal(6);
      });

      it("using named class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function NamedGrandparent() {
              (0, _classCallCheck3.default)(this, NamedGrandparent);
            }

            (0, _createClass3.default)(NamedGrandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedGrandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _NamedParent27 = function (_Grandparents$Grandpa13) {
              (0, _inherits3.default)(_NamedParent27, _Grandparents$Grandpa13);

              function _NamedParent27() {
                (0, _classCallCheck3.default)(this, _NamedParent27);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent27).apply(this, arguments));
              }

              return _NamedParent27;
            }(Grandparents.Grandparent);

            Object.defineProperty(_NamedParent27, "name", {
              value: 'NamedParent',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _NamedParent28 = Grandparents.Grandparent.onInherited(_NamedParent27);

                if (_NamedParent28 !== void 0) {
                  if (typeof _NamedParent28 == 'function' && _NamedParent28.name !== 'NamedParent') {
                    Object.defineProperty(_NamedParent28, "name", {
                      value: 'NamedParent',
                      configurable: true
                    });
                  }

                  _NamedParent27 = _NamedParent28;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedParent27;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild99 = function (_Parents$Parent47) {
              (0, _inherits3.default)(_NamedChild99, _Parents$Parent47);

              function _NamedChild99() {
                (0, _classCallCheck3.default)(this, _NamedChild99);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild99).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedChild99, [{
                key: 'childishness',
                value: function childishness() {
                  return 6;
                }
              }]);
              return _NamedChild99;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild99, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild100 = Parents.Parent.onInherited(_NamedChild99);

                if (_NamedChild100 !== void 0) {
                  if (typeof _NamedChild100 == 'function' && _NamedChild100.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild100, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild99 = _NamedChild100;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild99;
          }()
        };
        (0, _chai.expect)(new Children.Child().childishness()).to.equal(6);
      });
    });
    describe("can inherit instance methods from its parent", function () {
      it("using named class declarations", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent104 = function (_Grandparent22) {
            (0, _inherits3.default)(_Parent104, _Grandparent22);

            function _Parent104() {
              (0, _classCallCheck3.default)(this, _Parent104);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent104).apply(this, arguments));
            }

            (0, _createClass3.default)(_Parent104, [{
              key: 'hairColor',
              value: function hairColor() {
                return "red";
              }
            }]);
            return _Parent104;
          }(Grandparent);

          Object.defineProperty(_Parent104, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent105 = Grandparent.onInherited(_Parent104);

              if (_Parent105 !== void 0) {
                if (typeof _Parent105 == 'function' && _Parent105.name !== 'Parent') {
                  Object.defineProperty(_Parent105, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent104 = _Parent105;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent104;
        }();

        var Child = function () {
          var _Child101 = function (_Parent106) {
            (0, _inherits3.default)(_Child101, _Parent106);

            function _Child101() {
              (0, _classCallCheck3.default)(this, _Child101);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child101).apply(this, arguments));
            }

            return _Child101;
          }(Parent);

          Object.defineProperty(_Child101, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child102 = Parent.onInherited(_Child101);

              if (_Child102 !== void 0) {
                if (typeof _Child102 == 'function' && _Child102.name !== 'Child') {
                  Object.defineProperty(_Child102, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child101 = _Child102;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child101;
        }();

        (0, _chai.expect)(new Child().hairColor()).to.equal("red");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent107 = function (_Grandparent23) {
            (0, _inherits3.default)(_Parent107, _Grandparent23);

            function _Parent107() {
              (0, _classCallCheck3.default)(this, _Parent107);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent107).apply(this, arguments));
            }

            (0, _createClass3.default)(_Parent107, [{
              key: 'hairColor',
              value: function hairColor() {
                return "red";
              }
            }]);
            return _Parent107;
          }(Grandparent);

          Object.defineProperty(_Parent107, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent108 = Grandparent.onInherited(_Parent107);

              if (_Parent108 !== void 0) {
                if (typeof _Parent108 == 'function' && _Parent108.name !== 'Parent') {
                  Object.defineProperty(_Parent108, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent107 = _Parent108;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent107;
        }();
        var Child = function () {
          var _Child103 = function (_Parent109) {
            (0, _inherits3.default)(_Child103, _Parent109);

            function _Child103() {
              (0, _classCallCheck3.default)(this, _Child103);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child103).apply(this, arguments));
            }

            return _Child103;
          }(Parent);

          Object.defineProperty(_Child103, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child104 = Parent.onInherited(_Child103);

              if (_Child104 !== void 0) {
                if (typeof _Child104 == 'function' && _Child104.name !== 'Child') {
                  Object.defineProperty(_Child104, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child103 = _Child104;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child103;
        }();
        (0, _chai.expect)(new Child().hairColor()).to.equal("red");
      });

      it("using named class expressions saved as variables", function () {
        var Grandparent = function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, null, [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedGrandparent;
        }();

        var Parent = function () {
          var _NamedParent29 = function (_Grandparent24) {
            (0, _inherits3.default)(_NamedParent29, _Grandparent24);

            function _NamedParent29() {
              (0, _classCallCheck3.default)(this, _NamedParent29);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent29).apply(this, arguments));
            }

            (0, _createClass3.default)(_NamedParent29, [{
              key: 'hairColor',
              value: function hairColor() {
                return "red";
              }
            }]);
            return _NamedParent29;
          }(Grandparent);

          Object.defineProperty(_NamedParent29, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _NamedParent30 = Grandparent.onInherited(_NamedParent29);

              if (_NamedParent30 !== void 0) {
                if (typeof _NamedParent30 == 'function' && _NamedParent30.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent30, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent29 = _NamedParent30;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent29;
        }();
        var Child = function () {
          var _NamedChild101 = function (_Parent110) {
            (0, _inherits3.default)(_NamedChild101, _Parent110);

            function _NamedChild101() {
              (0, _classCallCheck3.default)(this, _NamedChild101);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild101).apply(this, arguments));
            }

            return _NamedChild101;
          }(Parent);

          Object.defineProperty(_NamedChild101, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild102 = Parent.onInherited(_NamedChild101);

              if (_NamedChild102 !== void 0) {
                if (typeof _NamedChild102 == 'function' && _NamedChild102.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild102, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild101 = _NamedChild102;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild101;
        }();
        (0, _chai.expect)(new Child().hairColor()).to.equal("red");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function Grandparent() {
              (0, _classCallCheck3.default)(this, Grandparent);
            }

            (0, _createClass3.default)(Grandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Grandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _temp57 = function (_Grandparents$Grandpa14) {
              (0, _inherits3.default)(_temp57, _Grandparents$Grandpa14);

              function _temp57() {
                (0, _classCallCheck3.default)(this, _temp57);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp57).apply(this, arguments));
              }

              (0, _createClass3.default)(_temp57, [{
                key: 'hairColor',
                value: function hairColor() {
                  return "red";
                }
              }]);
              return _temp57;
            }(Grandparents.Grandparent);

            Object.defineProperty(_temp57, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _temp58 = Grandparents.Grandparent.onInherited(_temp57);

                if (_temp58 !== void 0) {
                  if (typeof _temp58 == 'function' && _temp58.name !== 'class') {
                    Object.defineProperty(_temp58, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp57 = _temp58;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp57;
          }()
        };

        var Children = {
          Child: function () {
            var _temp59 = function (_Parents$Parent48) {
              (0, _inherits3.default)(_temp59, _Parents$Parent48);

              function _temp59() {
                (0, _classCallCheck3.default)(this, _temp59);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp59).apply(this, arguments));
              }

              return _temp59;
            }(Parents.Parent);

            Object.defineProperty(_temp59, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp60 = Parents.Parent.onInherited(_temp59);

                if (_temp60 !== void 0) {
                  if (typeof _temp60 == 'function' && _temp60.name !== 'class') {
                    Object.defineProperty(_temp60, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp59 = _temp60;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp59;
          }()
        };
        (0, _chai.expect)(new Children.Child().hairColor()).to.equal("red");
      });

      it("using named class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function NamedGrandparent() {
              (0, _classCallCheck3.default)(this, NamedGrandparent);
            }

            (0, _createClass3.default)(NamedGrandparent, null, [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedGrandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _NamedParent31 = function (_Grandparents$Grandpa15) {
              (0, _inherits3.default)(_NamedParent31, _Grandparents$Grandpa15);

              function _NamedParent31() {
                (0, _classCallCheck3.default)(this, _NamedParent31);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent31).apply(this, arguments));
              }

              (0, _createClass3.default)(_NamedParent31, [{
                key: 'hairColor',
                value: function hairColor() {
                  return "red";
                }
              }]);
              return _NamedParent31;
            }(Grandparents.Grandparent);

            Object.defineProperty(_NamedParent31, "name", {
              value: 'NamedParent',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _NamedParent32 = Grandparents.Grandparent.onInherited(_NamedParent31);

                if (_NamedParent32 !== void 0) {
                  if (typeof _NamedParent32 == 'function' && _NamedParent32.name !== 'NamedParent') {
                    Object.defineProperty(_NamedParent32, "name", {
                      value: 'NamedParent',
                      configurable: true
                    });
                  }

                  _NamedParent31 = _NamedParent32;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedParent31;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild103 = function (_Parents$Parent49) {
              (0, _inherits3.default)(_NamedChild103, _Parents$Parent49);

              function _NamedChild103() {
                (0, _classCallCheck3.default)(this, _NamedChild103);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild103).apply(this, arguments));
              }

              return _NamedChild103;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild103, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild104 = Parents.Parent.onInherited(_NamedChild103);

                if (_NamedChild104 !== void 0) {
                  if (typeof _NamedChild104 == 'function' && _NamedChild104.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild104, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild103 = _NamedChild104;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild103;
          }()
        };
        (0, _chai.expect)(new Children.Child().hairColor()).to.equal("red");
      });
    });
    describe("can inherit instance methods from its grandparent", function () {
      it("using named class declarations", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, [{
            key: 'hairColor',
            value: function hairColor() {
              return "red";
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent111 = function (_Grandparent25) {
            (0, _inherits3.default)(_Parent111, _Grandparent25);

            function _Parent111() {
              (0, _classCallCheck3.default)(this, _Parent111);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent111).apply(this, arguments));
            }

            return _Parent111;
          }(Grandparent);

          Object.defineProperty(_Parent111, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent112 = Grandparent.onInherited(_Parent111);

              if (_Parent112 !== void 0) {
                if (typeof _Parent112 == 'function' && _Parent112.name !== 'Parent') {
                  Object.defineProperty(_Parent112, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent111 = _Parent112;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent111;
        }();

        var Child = function () {
          var _Child105 = function (_Parent113) {
            (0, _inherits3.default)(_Child105, _Parent113);

            function _Child105() {
              (0, _classCallCheck3.default)(this, _Child105);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child105).apply(this, arguments));
            }

            return _Child105;
          }(Parent);

          Object.defineProperty(_Child105, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child106 = Parent.onInherited(_Child105);

              if (_Child106 !== void 0) {
                if (typeof _Child106 == 'function' && _Child106.name !== 'Child') {
                  Object.defineProperty(_Child106, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child105 = _Child106;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child105;
        }();

        (0, _chai.expect)(new Child().hairColor()).to.equal("red");
      });

      it("using anonymous class expressions with variable declaration", function () {
        var Grandparent = function () {
          function Grandparent() {
            (0, _classCallCheck3.default)(this, Grandparent);
          }

          (0, _createClass3.default)(Grandparent, [{
            key: 'hairColor',
            value: function hairColor() {
              return "red";
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return Grandparent;
        }();

        var Parent = function () {
          var _Parent114 = function (_Grandparent26) {
            (0, _inherits3.default)(_Parent114, _Grandparent26);

            function _Parent114() {
              (0, _classCallCheck3.default)(this, _Parent114);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent114).apply(this, arguments));
            }

            return _Parent114;
          }(Grandparent);

          Object.defineProperty(_Parent114, "name", {
            value: 'Parent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _Parent115 = Grandparent.onInherited(_Parent114);

              if (_Parent115 !== void 0) {
                if (typeof _Parent115 == 'function' && _Parent115.name !== 'Parent') {
                  Object.defineProperty(_Parent115, "name", {
                    value: 'Parent',
                    configurable: true
                  });
                }

                _Parent114 = _Parent115;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Parent114;
        }();
        var Child = function () {
          var _Child107 = function (_Parent116) {
            (0, _inherits3.default)(_Child107, _Parent116);

            function _Child107() {
              (0, _classCallCheck3.default)(this, _Child107);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child107).apply(this, arguments));
            }

            return _Child107;
          }(Parent);

          Object.defineProperty(_Child107, "name", {
            value: 'Child',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _Child108 = Parent.onInherited(_Child107);

              if (_Child108 !== void 0) {
                if (typeof _Child108 == 'function' && _Child108.name !== 'Child') {
                  Object.defineProperty(_Child108, "name", {
                    value: 'Child',
                    configurable: true
                  });
                }

                _Child107 = _Child108;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _Child107;
        }();
        (0, _chai.expect)(new Child().hairColor()).to.equal("red");
      });

      it("using named class expressions saved as variables", function () {
        var Grandparent = function () {
          function NamedGrandparent() {
            (0, _classCallCheck3.default)(this, NamedGrandparent);
          }

          (0, _createClass3.default)(NamedGrandparent, [{
            key: 'hairColor',
            value: function hairColor() {
              return "red";
            }
          }], [{
            key: 'onInherited',
            value: function onInherited(inheritor) {}
          }]);
          return NamedGrandparent;
        }();

        var Parent = function () {
          var _NamedParent33 = function (_Grandparent27) {
            (0, _inherits3.default)(_NamedParent33, _Grandparent27);

            function _NamedParent33() {
              (0, _classCallCheck3.default)(this, _NamedParent33);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent33).apply(this, arguments));
            }

            return _NamedParent33;
          }(Grandparent);

          Object.defineProperty(_NamedParent33, "name", {
            value: 'NamedParent',
            configurable: true
          });

          if ("onInherited" in Grandparent) {
            if (typeof Grandparent.onInherited == 'function') {
              var _NamedParent34 = Grandparent.onInherited(_NamedParent33);

              if (_NamedParent34 !== void 0) {
                if (typeof _NamedParent34 == 'function' && _NamedParent34.name !== 'NamedParent') {
                  Object.defineProperty(_NamedParent34, "name", {
                    value: 'NamedParent',
                    configurable: true
                  });
                }

                _NamedParent33 = _NamedParent34;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedParent33;
        }();
        var Child = function () {
          var _NamedChild105 = function (_Parent117) {
            (0, _inherits3.default)(_NamedChild105, _Parent117);

            function _NamedChild105() {
              (0, _classCallCheck3.default)(this, _NamedChild105);
              return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild105).apply(this, arguments));
            }

            return _NamedChild105;
          }(Parent);

          Object.defineProperty(_NamedChild105, "name", {
            value: 'NamedChild',
            configurable: true
          });

          if ("onInherited" in Parent) {
            if (typeof Parent.onInherited == 'function') {
              var _NamedChild106 = Parent.onInherited(_NamedChild105);

              if (_NamedChild106 !== void 0) {
                if (typeof _NamedChild106 == 'function' && _NamedChild106.name !== 'NamedChild') {
                  Object.defineProperty(_NamedChild106, "name", {
                    value: 'NamedChild',
                    configurable: true
                  });
                }

                _NamedChild105 = _NamedChild106;
              }
            } else {
              throw new TypeError("Attempted to call onInherited, but it was not a function");
            }
          }

          return _NamedChild105;
        }();
        (0, _chai.expect)(new Child().hairColor()).to.equal("red");
      });

      it("using anonymous class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function Grandparent() {
              (0, _classCallCheck3.default)(this, Grandparent);
            }

            (0, _createClass3.default)(Grandparent, [{
              key: 'hairColor',
              value: function hairColor() {
                return "red";
              }
            }], [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return Grandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _temp61 = function (_Grandparents$Grandpa16) {
              (0, _inherits3.default)(_temp61, _Grandparents$Grandpa16);

              function _temp61() {
                (0, _classCallCheck3.default)(this, _temp61);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp61).apply(this, arguments));
              }

              return _temp61;
            }(Grandparents.Grandparent);

            Object.defineProperty(_temp61, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _temp62 = Grandparents.Grandparent.onInherited(_temp61);

                if (_temp62 !== void 0) {
                  if (typeof _temp62 == 'function' && _temp62.name !== 'class') {
                    Object.defineProperty(_temp62, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp61 = _temp62;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp61;
          }()
        };

        var Children = {
          Child: function () {
            var _temp63 = function (_Parents$Parent50) {
              (0, _inherits3.default)(_temp63, _Parents$Parent50);

              function _temp63() {
                (0, _classCallCheck3.default)(this, _temp63);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_temp63).apply(this, arguments));
              }

              return _temp63;
            }(Parents.Parent);

            Object.defineProperty(_temp63, "name", {
              value: 'class',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _temp64 = Parents.Parent.onInherited(_temp63);

                if (_temp64 !== void 0) {
                  if (typeof _temp64 == 'function' && _temp64.name !== 'class') {
                    Object.defineProperty(_temp64, "name", {
                      value: 'class',
                      configurable: true
                    });
                  }

                  _temp63 = _temp64;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _temp63;
          }()
        };
        (0, _chai.expect)(new Children.Child().hairColor()).to.equal("red");
      });

      it("using named class expressions on object literal properties", function () {
        var Grandparents = {
          Grandparent: function () {
            function NamedGrandparent() {
              (0, _classCallCheck3.default)(this, NamedGrandparent);
            }

            (0, _createClass3.default)(NamedGrandparent, [{
              key: 'hairColor',
              value: function hairColor() {
                return "red";
              }
            }], [{
              key: 'onInherited',
              value: function onInherited(inheritor) {}
            }]);
            return NamedGrandparent;
          }()
        };

        var Parents = {
          Parent: function () {
            var _NamedParent35 = function (_Grandparents$Grandpa17) {
              (0, _inherits3.default)(_NamedParent35, _Grandparents$Grandpa17);

              function _NamedParent35() {
                (0, _classCallCheck3.default)(this, _NamedParent35);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedParent35).apply(this, arguments));
              }

              return _NamedParent35;
            }(Grandparents.Grandparent);

            Object.defineProperty(_NamedParent35, "name", {
              value: 'NamedParent',
              configurable: true
            });

            if ("onInherited" in Grandparents.Grandparent) {
              if (typeof Grandparents.Grandparent.onInherited == 'function') {
                var _NamedParent36 = Grandparents.Grandparent.onInherited(_NamedParent35);

                if (_NamedParent36 !== void 0) {
                  if (typeof _NamedParent36 == 'function' && _NamedParent36.name !== 'NamedParent') {
                    Object.defineProperty(_NamedParent36, "name", {
                      value: 'NamedParent',
                      configurable: true
                    });
                  }

                  _NamedParent35 = _NamedParent36;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedParent35;
          }()
        };

        var Children = {
          Child: function () {
            var _NamedChild107 = function (_Parents$Parent51) {
              (0, _inherits3.default)(_NamedChild107, _Parents$Parent51);

              function _NamedChild107() {
                (0, _classCallCheck3.default)(this, _NamedChild107);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NamedChild107).apply(this, arguments));
              }

              return _NamedChild107;
            }(Parents.Parent);

            Object.defineProperty(_NamedChild107, "name", {
              value: 'NamedChild',
              configurable: true
            });

            if ("onInherited" in Parents.Parent) {
              if (typeof Parents.Parent.onInherited == 'function') {
                var _NamedChild108 = Parents.Parent.onInherited(_NamedChild107);

                if (_NamedChild108 !== void 0) {
                  if (typeof _NamedChild108 == 'function' && _NamedChild108.name !== 'NamedChild') {
                    Object.defineProperty(_NamedChild108, "name", {
                      value: 'NamedChild',
                      configurable: true
                    });
                  }

                  _NamedChild107 = _NamedChild108;
                }
              } else {
                throw new TypeError("Attempted to call onInherited, but it was not a function");
              }
            }

            return _NamedChild107;
          }()
        };
        (0, _chai.expect)(new Children.Child().hairColor()).to.equal("red");
      });
    });
  });
});